<?php 

// +------------------------------------------------------------------+
// |                                                                  |
// | Copyright 1999-Present Kryptronic, Inc. All rights reserved.     |
// |                                                                  |
// | This software is copyrighted, trademarked, developed and         |
// | licensed by Kryptronic, Inc. This software is distributed        |
// | under license.                                                   |
// |                                                                  |
// | View the license agreement for more information.  Installation   |
// | of this software package indicates acceptance of the license     |
// | agreement.                                                       |
// |                                                                  |
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | IF INSTRUCTED TO EDIT THE $main_path_force VARIABLE, EDIT THE    |
// | VALUE BETWEEN THE SINGLE QUOTES ON THE FOLLOWING LINE.           |
// +------------------------------------------------------------------+

$main_path_force   = '';

$perms_level_files  = '777';
$perms_level_dirs   = '777';
$perms_level_exec   = '777';

// +------------------------------------------------------------------+
// | DO NOT EDIT BELOW THIS LINE.                                     |
// +------------------------------------------------------------------+

// +--
// | The following parameters are to be left alone.  We initially set
// | this script up to handle its own errors, run using the BackEnd
// | interface and to produce output (so we can use CORE_Error).  Right
// | before this script prints displays, we turn output off and destroy
// | the CORE_Display output buffer.
// +--

$interface = 'BackEnd';
$output    = 1;
$errhandle = 1;

// +--
// | Enter the importer script name if it has been changed.  We also
// | set the script up as a robot so cookies are not printed.
// +--

$importer_script = 'importer-europacart8-ccp51.php';
$importer_name   = 'ClickCartPro 5.1 (tiki)';
$robot           = 'Kryptronic Data Importer: ' . $importer_name;

// +--
// | Set permissions level for executable files and 
// | dirs to the same level as this file.
// +--

$thisfile = __FILE__;

while (preg_match('/\\\\/',$thisfile)) {$thisfile = preg_replace('/\\\\/','/',$thisfile);}

while (preg_match('/\/\//',$thisfile)) {$thisfile = preg_replace('/\/\//','/',$thisfile);}

$thisfile = preg_replace('/\/$/','',$thisfile);

$thisfile_perms = @substr(@decoct(@fileperms($thisfile)),3);

if ((!(empty($thisfile_perms))) && ($thisfile_perms == 755)) {

     $perms_level_exec = $thisfile_perms;

} // End of if statement.

// +--
// | Main program loader.  This object call creates an instance
// | of the COREmain class.  When the exec() function runs, the
// | program runs and produces output.  We exit() afterwards.
// +--

$coremain = new COREmain;

$coremain->exec(array('core.main_path_force'    => $main_path_force,
                      'core.interface'          => $interface,
                      'core.output'             => $output,
                      'core.errhandle'          => $errhandle,
                      'core.perms_level_files'  => $perms_level_files,
                      'core.perms_level_dirs'   => $perms_level_dirs,
                      'core.perms_level_exec'   => $perms_level_exec,
                      'importer.script_name'    => $importer_script,
                      'importer.name'           => $importer_name,
                      'core.robot'              => $robot));

// +--
// | Exit() is called from within the core during it's shutdown
// | function, however it's good practice to call it here as well
// | to handle garbage collection.
// +--

exit();

// +------------------------------------------------------------------+
// | Class Definition                                                 |
// +------------------------------------------------------------------+

class COREmain {

// +--
// | This class is used to verify the PHP environment we're running
// | in, load and execute the CORE class and provide error handling
// | outside of the scope of the main core class.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                                  |
// +------------------------------------------------------------------+

var $class   = 'COREmain';
var $version = '8.0.0';
var $cerror;

// +------------------------------------------------------------------+
// | Constructor Function                                             |
// +------------------------------------------------------------------+

function COREmain () {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec                                                   |
// +------------------------------------------------------------------+

function exec ($input = array()) {

// +--
// | This routine is run to run the internals of the class.  Main class
// | logic is contained in this function.
// +--

// +--
// | Globalize our input array.
// +--

if (!(empty($input))) {

     foreach ($input as $key => $value) {$this->globals($key,$value);}

} // End of if statement.

// +--
// | Set error handling up to output errors to the browser.  We handle
// | all errors except for E_NOTICE errors.
// +--

ini_set('display_errors','1');

error_reporting(E_ALL ^ E_NOTICE);

set_error_handler(array(&$this,'error_display'));

// +--
// | Determine the directory from where we're running this program.
// +--

$path = $this->globals('core.main_path_force');

if ((!(empty($path))) && (@file_exists($path))) {

     $path = $this->globals('core.main_path_force');

} elseif (@file_exists(dirname(__FILE__))) {

     $path = dirname(__FILE__);

} elseif (@file_exists(getcwd())) {

     $path = getcwd();

} elseif (@file_exists(dirname($_SERVER['PATH_TRANSLATED']))) {

     $path = dirname($_SERVER['PATH_TRANSLATED']);

} elseif (@file_exists(dirname($_SERVER['SCRIPT_FILENAME']))) {

     $path = dirname($_SERVER['SCRIPT_FILENAME']);

} else {

     $errstr = "

     <p>This script could not determine the directory from which it is 
     being executed.  You need to edit the scripts 'index.php', 'admin.php' 
     and 'installer.php' and enter a value for the \$main_path_force 
     variable at the top of those scripts. Follow the instructions in each of 
     those scripts for more information.</p>

     <p>If you have already edited the \$main_path_force variable and are 
     seeing this message again, the value you used for that variable 
     appears to be incorrect.  Please try again.</p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Format our working directory we've just determined and globalize it.
// +--

$path = $this->paths_convert($path);

$this->globals('core.main_path_force',$path);

// +--
// | Include our config.php in the public directory.  Globalize the 
// | config array.
// +--

if (@file_exists($this->globals('core.main_path_force') . '/config.php')) {

     include($this->globals('core.main_path_force') . '/config.php');

     foreach ($config as $key => $value) {$this->globals($key,$value);}

     unset($config);

} // End of if statement.

// +--
// | If the $config array key 'core.path_private' was not defined,
// | we had a problem and need to error out.
// +--

$pathpriv = $this->globals('core.path_private');

if (empty($pathpriv)) {

     $errstr = "

     <p>It appears you have not run the core 
     installer script.  You need to run the installer script before
     accessing this script.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Our private config file will be included automatically
// | by the core when it loads up.
// |
// | Now that we have our public config file included,
// | we can include our main core file.
// +--

$privpath = $this->globals('core.path_private');

if (@file_exists($privpath . '/core/CORE/CORE.php')) {

     include_once($privpath . '/core/CORE/CORE.php');

// +--
// | If there is a problem finding the file, we error out.
// +--

} else {

     $errstr = "

     <p>This script could not locate the file 'CORE.php' in the
     directory:</p>

     <p>{$privpath}/core/CORE</p>

     <p>This could be the result of an incomplete installation.  The
     configuration files created by the installer appear to be complete, 
     however the installation of the codebase is incomplete.  This is a
     fatal error that cannot be resolved automatically.  Reinstall the
     software to continue.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | If we were able to include our main core file, we can run the core.
// | Above we set 'output' to '0' and 'errhandle' to '1' so the core will 
// | produce no output and not trigger errors internally.  There is no need 
// | to check for errors at this level.  
// |
// | Create the CORE object.
// +--

global $xglobal_cache;

$core = new CORE($xglobal_cache);

if ($core->IsError($core->cerror)) {

     trigger_error($core->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Run the importer.  We pass it's constructor a reference to our
// | CORE object.
// +--

$importer = new COREimporter($core);

if ($core->IsError($importer->cerror)) {

     trigger_error($importer->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

$importer->exec();

// +--
// | Run core shutdown method.
// +--

$core->shutdown();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: globals                                                |
// +------------------------------------------------------------------+

function globals ($name = '',$value = null,$default = null) {

// +--
// | This function maintains a global array of global variables for
// | use within the program.  Global variables can be set, changed and
// | obtained from this function.
// +--

global $xglobal_cache;

// +--
// | If the request contained a default identifier (passed as a true
// | value), we set a default value if the global doesn't exist.
// +--

if ((!(empty($name))) && (isset($value)) && (isset($default)) && (!(isset($xglobal_cache[$name])))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Set requests have both a name and value passed
// | to this function.
// +--

if ((!(empty($name))) && (isset($value)) && (!(isset($default)))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Get requests have only a global variable name
// | passed to this function.
// +--

if ((!(empty($name))) && (isset($xglobal_cache[$name]))) {

     return $xglobal_cache[$name];

} // End of if statement.

// +--
// | All other requests result in a null return value.
// +--

return null;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_convert                                          |
// +------------------------------------------------------------------+

function paths_convert ($string) {

// +--
// | This function converts filesystem paths to unix-style and strips
// | any trailing slashes.
// +--

while (preg_match('/\\\\/',$string)) {$string = preg_replace('/\\\\/','/',$string);}

while (preg_match('/\/\//',$string)) {$string = preg_replace('/\/\//','/',$string);}

$string = preg_replace('/\/$/','',$string);

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_strip                                            |
// +------------------------------------------------------------------+

function paths_strip ($string) {

// +--
// | This function strips full server paths from a given string for
// | security purposes.
// +--

$pathpub   = $this->globals('core.path_public');
$pathpriv  = $this->globals('core.path_private');
$pathforce = $this->globals('core.main_path_force');

$string = str_replace('\\','/',$string);

if (!(empty($pathforce))) {

     $find   = preg_quote($pathforce . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.
 
if (!(empty($pathpub))) {

     $find   = preg_quote($pathpub . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

if (!(empty($pathpriv))) {

     $find   = preg_quote($pathpriv . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_display                                          |
// +------------------------------------------------------------------+

function error_display ($errno = '',$errstr = '',$errfile = '',$errline = '') {

// +--
// | This function is called via PHP when an error is encountered.
// | Scripts pass errors through this function via PHP's trigger_error
// | function using:
// |
// | trigger_error('some_error_message',E_USER_ERROR);
// | 
// | PHP also passes errors through this function without script
// | intervention.
// +--

// +--
// | If we've hit this function with a suppressed error or an E_STRICT
// | or E_NOTICE error, we return.
// +--

if ((error_reporting() == 0) || ($errno == E_NOTICE) || ($errno == E_STRICT)) {

     return 1;

} // End of if statement.

// +--
// | If we are currently buffering output, destroy the buffer
// | and reset buffer status.
// +--

if ($this->globals('installer.buffer_status')) {

     @ob_end_clean();

     $this->globals('installer.buffer_status',0);

} // End of if statement.

// +--
// | Modify our $errfile if it is non-blank.  We want to remove
// | full paths from error messages to increase security.
// +--

if ($errfile) {$errfile = $this->paths_strip($errfile);}

// +--
// | Modify our $errstr if it is non-blank.  We want to add <p>
// | tags if they're not there.
// +--

if (($errstr) && (!(preg_match('/<p>/',$errstr)))) {

     $errstr = '<p>' . $errstr . '</p>';

} // End of if statement.

// +--
// | Print output header.
// +--

print $this->error_div_header();

// +--
// | Print output content.
// +--

if ($errstr) {print $this->error_div_content($errstr);}

// +--
// | Print output info.
// +--

if ($errno && $errline && $errfile) {print $this->error_div_info($errno,$errline,$errfile);}

// +--
// | Print output footer.
// +--

print $this->error_div_footer();

// +--
// | This was a fatal error so we exit.
// +--

exit();

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_header                                       |
// +------------------------------------------------------------------+

function error_div_header () {

// +--
// | This function prints the error header.
// +--

$xhtml = <<<ENDOFTEXT

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 

<style type="text/css" media="all">

body {
     font-family: Verdana, Tahoma, Arial, sans-serif;
     font-size: 12px;
     color: #333333;
     font-weight: normal;
     text-align: left;
     background-color: #F5F5F5;
     margin: 20px;
     }

a {
     color: #30569D;
     text-decoration: none;
     font-weight: normal;
     }

a:hover {
     text-decoration: underline;
     }

.strong {
     font-weight: bold;
     }

#content {
     color: #333333;
     background-color: #FFFFFF;
     border: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: 0px auto 0px auto;
     -moz-border-radius: 8px 8px 0px 0px;
     -webkit-border-radius: 8px 8px 0px 0px;
     border-radius: 8px 8px 0px 0px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     line-height: 1.5em;
     }

#info {
     color: #333333;
     background-color: #FFFFFF;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     border-bottom: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: 0px auto 0px auto;
     -moz-border-radius: 0px 0px 8px 8px;
     -webkit-border-radius: 0px 0px 8px 8px;
     border-radius: 0px 0px 8px 8px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     font-size: 11px;
     }

#pgtitle {
     color: #4E70AE;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     font-weight: bold;
     font-size: 18px;
     }

</style>

<title>Script Execution Error</title>

</head>

<body>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_content                                      |
// +------------------------------------------------------------------+

function error_div_content ($errstr = '') {

// +--
// | This function prints the error contet.
// +--

$xhtml = <<<ENDOFTEXT

<div id="content">

<div id="pgtitle">Script Execution Error</div>

{$errstr}

</div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_info                                         |
// +------------------------------------------------------------------+

function error_div_info ($errno = '',$errline = '',$errfile = '') {

// +--
// | This function prints the error info.
// +--

$xhtml = <<<ENDOFTEXT

<div id="info">File: {$errfile} Line: {$errline} Error Number: {$errno}</div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_footer                                       |
// +------------------------------------------------------------------+

function error_div_footer () {

// +--
// | This function prints the error footer.
// +--

$xhtml = <<<ENDOFTEXT

</body>

</html>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Core Class                                              |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Class Definition: COREimporter                                   |
// +------------------------------------------------------------------+

class COREimporter {

// +--
// | This class handles data imports into the core  This script is to 
// | be considered standalone software and it's architecture and 
// | methodology are not indicative of the core core codebase.  
// | Do not use code in this COREimporter class as a basis for core
// | core or component code.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                                  |
// +------------------------------------------------------------------+

var $class   = 'COREimporter';
var $version = '8.0.0';
var $cerror;

var $dbrows_atonce = 100;

var $CORE;
var $CORE_Display;
var $CORE_DB;
var $CORE_DBX;
var $CORE_Crypt;
var $CORE_File;

// +------------------------------------------------------------------+
// | Constructor Function                                             |
// +------------------------------------------------------------------+

function COREimporter ($core_object = '') {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Define our CORE object.
// +--

$this->CORE =& $core_object;

// +--
// | Quick object load: CORE_Display
// +--

$this->CORE_Display =& $this->CORE->quick_object('CORE_Display','core');

if ($this->CORE->IsError($this->CORE_Display)) {$this->cerror = $this->CORE_Display; return;}

// +--
// | Quick object load: CORE_DB
// +--

$this->CORE_DB =& $this->CORE->quick_object('CORE_DB','core','CORE_DB_1');

if ($this->CORE->IsError($this->CORE_DB)) {$this->cerror = $this->CORE_DB; return;}

// +--
// | Quick object load: CORE_Crypt
// +--

$this->CORE_Crypt =& $this->CORE->quick_object('CORE_Crypt','core');

if ($this->CORE->IsError($this->CORE_Crypt)) {$this->cerror = $this->CORE_Crypt; return;}

// +--
// | Quick object load: CORE_File
// +--

$this->CORE_File =& $this->CORE->quick_object('CORE_File','core');

if ($this->CORE->IsError($this->CORE_File)) {$this->cerror = $this->CORE_File; return;}

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Wrapper                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: exec                                                   |
// +------------------------------------------------------------------+

function exec () {

// +--
// | This function runs the internals of the importer program.
// +--

// +--
// | Define some important variables.
// +--

$this->CORE->globals('importer.numsteps','13');

// +--
// | Start buffering output.
// +--

if (!($this->CORE->globals('importer.buffer_status'))) {

     @ob_start();

     $this->CORE->globals('importer.buffer_status',1);

} // End of if statement.

// +--
// | Start processing.
// +--

$result = $this->exec_do();

if ($this->CORE->IsError($result)) {

     trigger_error($result->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Finish buffering output.
// +--

if ($this->CORE->globals('importer.buffer_status')) {

     $buffered_output = @ob_get_contents();

     @ob_end_clean();

     $this->CORE->globals('importer.buffered_output',$buffered_output);

     $this->CORE->globals('importer.buffer_status',0);

} // End of if statement.

// +--
// | Kill the buffering in the core and set our display status to
// | false.
// +--

$this->CORE_Display->buffer('CLEAN');

$this->CORE->globals('core.output',0);

// +--
// | Print the display.
// +--

$this->disp();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_do                                                |
// +------------------------------------------------------------------+

function exec_do () {

// +--
// | This function processes the main logic of the importer.
// +--

// +--
// | Define the step we're on.
// +--

$step = $this->CORE->globals('core_cgi.step');

if (!($step)) {$step = 'Intro';}

// +--
// | Get password info from form input and present the right 
// | interface.
// +--

$password = $this->CORE->globals('core.password');

if (!(empty($password))) {

     $import_password = $this->CORE->globals('core_cgi.import_password');

     if (!($import_password)) {

          $step = 'Password';

     } elseif (md5($import_password) != $password) {

          $message = "The password you entered is incorrect.  Please try again.";
          $step    = 'Password';

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} elseif ($step != 'IntroP') {

     $step = 'Intro';

} // End of if statement.

// +--
// | Check the status of our license agreement acceptance.
// +--

$license_agree = $this->CORE->globals('core_cgi.license_agree');

if (empty($license_agree)) {

          if ($step != 'Password' && $step != 'Intro') {

          $message = "You did not agree to the terms and conditions in the EULA.  
                      You must agree to these terms and conditions to continue.";

          if ($step == 'IntroP') {$step = 'Intro';}

          else {$step = 'Password';}

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} // End of if statement.

// +--
// | Execute our step.
// +--

$result = $this->exec_step($step);

if ($this->CORE->IsError($result)) {return $result;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_step                                              |
// +------------------------------------------------------------------+

function exec_step ($step = 'Default') {

// +--
// | This function executes importer steps.
// +--

// +--
// | Use the step to figure out what we need to be doing.  If the
// | step is blank, we default to step I.  A list of the steps is
// | below:
// |
// | Step Number  Action          
// | -----------  -------------------
// | Default      Default Invalid Info Screen
// | Password     Password Collection
// | Location     Installation Location
// | LocationP    Installation Location - Process
// | Settings     Software Settings
// | SettingsP    Software Settings - Process
// | Media        Media Files
// | MediaP       Media Files - Process
// | CustAcct     Customer Accounts
// | CustAcctP    Customer Accounts - Processs
// | Affiliates   Affiliate Accounts 
// | AffiliatesP  Affiliate Accounts - Process
// | Maillist     Maillist Accounts
// | MaillistP    Maillist Accounts - Process
// | Category     Categories
// | CategoryP    Categories - Process
// | Product      Products
// | ProductP     Products - Process
// | ProdOpt      Product Options
// | ProdOptP     Product Options - Process
// | Orders       Orders
// | OrdersP      Orders - Process
// | OrderItems   OrderItems
// | OrderItemsP  OrderItems - Process
// | Discounts    Discount Codes
// | DiscountsP   Discount Codes - Process
// | HtmlPage     HTML Pages (User Defined)
// | HtmlPageP    HTML Pages (User Defined) - Process
// | Final        Final Confirm Display
// +--

switch ($step) {

     case "Password":
          $result = $this->step_Password();
          break;

     case "Location":
          $result = $this->step_Location();
          break;

     case "LocationP":
          $result = $this->step_LocationP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Location();
          }
          break;

     case "Settings":
          $result = $this->step_Settings();
          break;

     case "SettingsP":
          $result = $this->step_SettingsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Settings();
          }
          break;

     case "Media":
          $result = $this->step_Media();
          break;

     case "MediaP":
          $result = $this->step_MediaP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Media();
          }
          break;

     case "CustAcct":
          $result = $this->step_CustAcct();
          break;

     case "CustAcctP":
          $result = $this->step_CustAcctP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_CustAcct();
          }
          break;

     case "Affiliates":
          $result = $this->step_Affiliates();
          break;

     case "AffiliatesP":
          $result = $this->step_AffiliatesP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Affiliates();
          }
          break;

     case "Maillist":
          $result = $this->step_Maillist();
          break;

     case "MaillistP":
          $result = $this->step_MaillistP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Maillist();
          }
          break;

     case "Category":
          $result = $this->step_Category();
          break;

     case "CategoryP":
          $result = $this->step_CategoryP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Category();
          }
          break;

     case "Product":
          $result = $this->step_Product();
          break;

     case "ProductP":
          $result = $this->step_ProductP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Product();
          }
          break;

     case "ProdOpt":
          $result = $this->step_ProdOpt();
          break;

     case "ProdOptP":
          $result = $this->step_ProdOptP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_ProdOpt();
          }
          break;

     case "Orders":
          $result = $this->step_Orders();
          break;

     case "OrdersP":
          $result = $this->step_OrdersP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Orders();
          }
          break;

     case "OrderItems":
          $result = $this->step_OrderItems();
          break;

     case "OrderItemsP":
          $result = $this->step_OrderItemsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_OrderItems();
          }
          break;

     case "Discounts":
          $result = $this->step_Discounts();
          break;

     case "DiscountsP":
          $result = $this->step_DiscountsP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Discounts();
          }
          break;

     case "HtmlPage":
          $result = $this->step_HtmlPage();
          break;

     case "HtmlPageP":
          $result = $this->step_HtmlPageP();
          if ($this->CORE->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_HtmlPage();
          }
          break;

     case "Final":
          $result = $this->step_Final();
          break;

     default:
          $result = $this->step_Default();
          break;

} // End of switch statement.

// +--
// | Return the result.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Steps                                                   |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: step_Default                                           |
// +------------------------------------------------------------------+

function step_Default () {

// +--
// | Importer Function Step.
// +--

// +--
// | Default Invalid Info Screen
// | 
// | This function prints a page indicating the importer was hit 
// | with invalid information and prints a valid importer link.
// +--

$insname = $this->CORE->globals('importer.script_name');

print <<<ENDOFTEXT

<p>You have accessed this importer script using invalid data.  In 
order to use the importer script, please follow the link below:</p>

<p><a href="{$insname}" title="importer">Click here to run the importer script.</a></p>

ENDOFTEXT;

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Password                                          |
// +------------------------------------------------------------------+

function step_Password () {

// +--
// | Importer Function Step.
// +--

// +--
// | Password Collection
// | 
// | This function prints a form to be completed by the user to 
// | submit a password for this importer script.  This screen is 
// | accessed when a password already exists for the importer.
// +--

$software = $this->CORE->globals('importer.name');

print <<<ENDOFTEXT

<p>This data importer script is designed to import data from a {$software} 
installation into the primary database connection which this 
script is currenly associated with.</p>

<p><strong>Items that are imported by this script</strong>: 
Settings, media files, customer accounts, mail list accounts, affiliate accounts, 
categories, products, product options, orders, discount codes, custom checkout fields, 
and HTML pages (user defined).</p>

<p><strong>Items that are not imported by this script</strong>:  
Online processing settings, realtime shipping configuration information, 
custom shipping scripts, checkout form modifications, skins and general display 
changes made to HTML elements.</p>

<p><strong>Please Note</strong>: If you have configured a database connection 
within your {$software} installation, that data source will be used for any 
tables you have exported to the database.  The access information needed to 
connect to that RDBMS will be automatically pulled from your {$software} 
installation.  There is no need to enter that information into this importer 
script.</p>

ENDOFTEXT;

// +--
// | Define the form.
// +--

$header = <<<ENDOFTEXT

<p>This importer script is protected by a password that was set up
during the initial installation of this program.  Enter the password 
you selected to protect the installer script below then click the 
'Continue' button at the bottom of this page to import data using this 
importer script.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_password';
$fields[0]['name']     = 'Installer Password';
$fields[0]['type']     = 'PASSWORD';
$fields[0]['required'] = '1';

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Enter the password below that you selected to permit controlled 
access to the software installer.  If you do not remember the installer password 
you selected during the initial installation of this program, edit the 
'config.php' file in this directory.  Delete the MD5 hash assigned to the 
'core.password' variable to create a new password.</p>

ENDOFTEXT;

$fields[1]['id']       = 'license_agree';
$fields[1]['name']     = 'License Agreement';
$fields[1]['type']     = 'CHECKBOX';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('1' => 'I agree to the terms and conditions in the EULA.');

$fields[1]['desc']     = <<<ENDOFTEXT

<p>Installation and use of this program requires you read and accept the 
End User License Agreement (EULA) distributed with this software.  Follow 
the link below to review the EULA.  The EULA is distributed in Adobe PDF 
format.  You will need Acrobat Reader, which is freely available from Adobe, 
to review the EULA.</p>

<p><a href="license.pdf" rel="external" title="License">Click here to review the EULA.</a></p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'Location'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Location                                          |
// +------------------------------------------------------------------+

function step_Location () {

// +--
// | Importer Function Step: 
// |
// | Installation Location
// +--

$this->CORE->globals('importer.step','1');
$this->CORE->globals('importer.steptext','Installation Location');

// +--
// | Print the form.
// +--

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below the server paths for the data and media directories 
for your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_dirdata';
$fields[0]['name']     = 'Source Data Directory Path';
$fields[0]['type']     = 'TEXT-LONG';
$fields[0]['required'] = '1';

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Enter the absolute directory path to the data directory used by your 
{$software} installation.  If you do not know what your directory path 
is, you can locate it in your {$software} cp-app.cgi or cp-app.pl file.  It 
is assigned in that file to the variable \$server_data_path.</p>

<p>Example: /home/username/ccp51/data or C:/Inetpub/db/ccp51</p>

ENDOFTEXT;

$fields[1]['id']       = 'import_dirmedia';
$fields[1]['name']     = 'Source Media Directory Path';
$fields[1]['type']     = 'TEXT-LONG';
$fields[1]['required'] = '1';

$fields[1]['desc']     = <<<ENDOFTEXT

<p>Enter the absolute directory path to the media directory used by your 
{$software} installation.  If you do not know what your directory path 
is, you can locate it in your {$software} cp-app.cgi or cp-app.pl file.  It 
is assigned in that file to the variable \$server_media_path.</p>

<p>Example: /home/username/www/ccp51/media or C:/Inetpub/wwwroot/ccp51/media</p>

ENDOFTEXT;

$fields[2]['id']       = 'import_destapp';
$fields[2]['type']     = 'HIDDEN';
$fields[2]['required'] = '1';
$fields[2]['value']    = 'ecom';

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'LocationP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_LocationP                                         |
// +------------------------------------------------------------------+

function step_LocationP () {

// +--
// | Importer Function Step: 
// |
// | Installation Location - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Strip off any trailing slashes and convert to Unix style
// | paths/filenames.
// +--

$import_dirdata  = $this->CORE->paths_convert($fd['import_dirdata']);
$import_dirmedia = $this->CORE->paths_convert($fd['import_dirmedia']);

$this->CORE->globals('core_cgi.import_dirdata',$import_dirdata);
$this->CORE->globals('core_cgi.import_dirmedia',$import_dirmedia);

// +--
// | Check the formdata submission items and append error messages as
// | we go.
// +--

$errorcount = 0;

$errmsg     = "The following errors were encountered while attempting 
               to process your request: ";

// +--
// | Check the data directory.
// +--

if (!(@file_exists($import_dirdata . '/tables'))) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the data directory used by your
                 software installation is incorrect.  The path specified does not 
                 appear to contain any software installation files.";

} // End of if statement.

// +--
// | Check the media directory.
// +--

if (!(@file_exists($import_dirmedia . '/images'))) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the media directory used by your
                 software installation is incorrect.  The path specified does not 
                 appear to contain any software installation files.";

} // End of if statement.

// +--
// | Return errors if we have any at this point.
// +--

if ($errorcount) {

     $result = $this->CORE->RaiseError($errmsg);

     return $result;

} // End of if statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. The destination component and your source directory paths 
            have been validated.  You can now continue through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Settings();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Settings                                          |
// +------------------------------------------------------------------+

function step_Settings () {

// +--
// | Importer Function Step: 
// |
// | Software Settings Import
// +--

$this->CORE->globals('importer.step','2');
$this->CORE->globals('importer.steptext','Software Settings Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import settings from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Software Settings Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import settings from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the settings from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'SettingsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_SettingsP                                         |
// +------------------------------------------------------------------+

function step_SettingsP () {

// +--
// | Importer Function Step: 
// |
// | Software Settings Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing settings.  No 
                 settings have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Media();

} // End of if statement.

// +--
// | Load the settings.
// +--

$settings1 = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings1)) {return $settings1;}

$settings2 = $this->import_load_settings('accounting.csv');

if ($this->CORE->IsError($settings2)) {return $settings2;}

$settings = array_merge($settings1,$settings2);

// +--
// | Create our translation array.
// +--

$translation = array();

$translation['site_owner_name']                    = array('dest' => 'site_name', 'filter' => '', 'dvalue' => '');
$translation['site_owner_address']                 = array('dest' => 'siteowneradd', 'filter' => '', 'dvalue' => '');
$translation['site_owner_city']                    = array('dest' => 'siteownercity', 'filter' => '', 'dvalue' => '');
$translation['site_owner_stateprov']               = array('dest' => 'siteownerstateprov', 'filter' => '', 'dvalue' => '');
$translation['site_owner_zip']                     = array('dest' => 'siteownerzip', 'filter' => '', 'dvalue' => '');
$translation['site_owner_country']                 = array('dest' => 'siteownercountry', 'filter' => '', 'dvalue' => '');
$translation['site_owner_phone']                   = array('dest' => 'siteownerphone', 'filter' => '', 'dvalue' => '');
$translation['site_owner_fax']                     = array('dest' => 'siteownerfax', 'filter' => '', 'dvalue' => '');
$translation['site_owner_email_address']           = array('dest' => 'default_contact_email', 'filter' => '', 'dvalue' => '');
$translation['html_site_name']                     = array('dest' => 'site_name', 'filter' => '', 'dvalue' => '');
$translation['site_order_email_prim']              = array('dest' => 'primordemail', 'filter' => '', 'dvalue' => '');
$translation['store_send_email_prim']              = array('dest' => 'primordemailsend', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['site_order_email_sec']               = array('dest' => 'ccordemail', 'filter' => '', 'dvalue' => '');
$translation['store_noncat_catcount']              = array('dest' => 'splashcatnum', 'filter' => '', 'dvalue' => '');
$translation['store_noncat_smcount']               = array('dest' => 'splashprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_new_smcount']                  = array('dest' => 'newprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_best_smcount']                 = array('dest' => 'bestprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_specials_smcount']             = array('dest' => 'specprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_products_to_display_per_page'] = array('dest' => 'proddisppg', 'filter' => '', 'dvalue' => '');
$translation['store_disable_store']                = array('dest' => 'disablestore', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_disp_prodnums']                = array('dest' => 'dispprodnums', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_use_email_a_friend']           = array('dest' => 'emailfriend', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_use_relatedprods']             = array('dest' => 'relatedprods', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['salescript_use']                     = array('dest' => 'usesalescript', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_minorder_amt']                 = array('dest' => 'minorderamt', 'filter' => '', 'dvalue' => '');
$translation['order_number_type']                  = array('dest' => 'ordernumtype', 'filter' => '', 'dvalue' => '');
$translation['order_number_prefix']                = array('dest' => 'ordernumprefix', 'filter' => '', 'dvalue' => '');
$translation['store_small_image_width']            = array('dest' => 'imgsizeprodsm', 'filter' => '', 'dvalue' => '');
$translation['store_cat_image_width']              = array('dest' => 'imgsizecat', 'filter' => '', 'dvalue' => '');
$translation['store_large_image_width']            = array('dest' => 'imgsizeprodlg', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_weight']             = array('dest' => 'shipminweight', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_length']             = array('dest' => 'shipminlength', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_width']              = array('dest' => 'shipminwidth', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_height']             = array('dest' => 'shipminheight', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_dimstatusw']         = array('dest' => 'presdimerr', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['ship_real_error_dimstatusd']         = array('dest' => 'presweighterr', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['ship_def_error_name']                = array('dest' => 'shiperrname', 'filter' => '', 'dvalue' => '');
$translation['ship_def_error_price']               = array('dest' => 'shiperramt', 'filter' => '', 'dvalue' => '');
$translation['ship_def_handle']                    = array('dest' => 'shiphandlecharge', 'filter' => '', 'dvalue' => '');
$translation['remote_html_post_use']               = array('dest' => 'ecomremoteactive', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['remote_html_post_url']               = array('dest' => 'ecomremoteurls', 'filter' => '', 'dvalue' => '');
$translation['pt_acctrec']                         = array('dest' => 'ptacctrec', 'filter' => '', 'dvalue' => '');
$translation['pt_expdisc']                         = array('dest' => 'ptexpdisc', 'filter' => '', 'dvalue' => '');
$translation['pt_expdiscd']                        = array('dest' => 'ptexpdiscd', 'filter' => '', 'dvalue' => '');
$translation['pt_expdisct']                        = array('dest' => 'ptexpdisct', 'filter' => '', 'dvalue' => '');
$translation['pt_expsale']                         = array('dest' => 'ptexpsale', 'filter' => '', 'dvalue' => '');
$translation['pt_expsaled']                        = array('dest' => 'ptexpsaled', 'filter' => '', 'dvalue' => '');
$translation['pt_expsalet']                        = array('dest' => 'ptexpsalet', 'filter' => '', 'dvalue' => '');
$translation['pt_incitem']                         = array('dest' => 'ptincitem', 'filter' => '', 'dvalue' => '');
$translation['pt_incitemt']                        = array('dest' => 'ptincitemt', 'filter' => '', 'dvalue' => '');
$translation['pt_incship']                         = array('dest' => 'ptincship', 'filter' => '', 'dvalue' => '');
$translation['pt_incshipd']                        = array('dest' => 'ptincshipd', 'filter' => '', 'dvalue' => '');
$translation['pt_incshipt']                        = array('dest' => 'ptincshipt', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxc']                         = array('dest' => 'ptinctaxc', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxcd']                        = array('dest' => 'ptinctaxcd', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxct']                        = array('dest' => 'ptinctaxct', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxs']                         = array('dest' => 'ptinctaxs', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxsd']                        = array('dest' => 'ptinctaxsd', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxst']                        = array('dest' => 'ptinctaxst', 'filter' => '', 'dvalue' => '');
$translation['pt_payment']                         = array('dest' => 'ptpayment', 'filter' => '', 'dvalue' => '');
$translation['pt_paymentd']                        = array('dest' => 'ptpaymentd', 'filter' => '', 'dvalue' => '');
$translation['pt_paymentt']                        = array('dest' => 'ptpaymentt', 'filter' => '', 'dvalue' => '');
$translation['qb_acctrec']                         = array('dest' => 'qbacctrec', 'filter' => '', 'dvalue' => '');
$translation['qb_bankacc']                         = array('dest' => 'qbbankacc', 'filter' => '', 'dvalue' => '');
$translation['qb_expdisc']                         = array('dest' => 'qbexpdisc', 'filter' => '', 'dvalue' => '');
$translation['qb_expdiscd']                        = array('dest' => 'qbexpdiscd', 'filter' => '', 'dvalue' => '');
$translation['qb_expsale']                         = array('dest' => 'qbexpsale', 'filter' => '', 'dvalue' => '');
$translation['qb_expsaled']                        = array('dest' => 'qbexpsaled', 'filter' => '', 'dvalue' => '');
$translation['qb_incitem']                         = array('dest' => 'qbincitem', 'filter' => '', 'dvalue' => '');
$translation['qb_incship']                         = array('dest' => 'qbincship', 'filter' => '', 'dvalue' => '');
$translation['qb_incshipd']                        = array('dest' => 'qbincshipd', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxc']                         = array('dest' => 'qbinctaxc', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxcd']                        = array('dest' => 'qbinctaxcd', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxs']                         = array('dest' => 'qbinctaxs', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxsd']                        = array('dest' => 'qbinctaxsd', 'filter' => '', 'dvalue' => '');

// +--
// | Set up our table.
// +--

$app = $this->CORE->globals('core_cgi.import_destapp');

$table = 'core_settings';

// +--
// | Work with the translation array.
// +--

foreach ($translation as $key => $info) {

     if (isset($settings[$key])) {

          $value = $settings[$key];

          if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
          if (!(empty($info['filter']))) {$value = $this->import_filter($info['filter'],$value,$settings);}

          $data = array('value' => "$value");

          $update_clause = $this->CORE_DB->clause_update(array('table'      => 'core_settings',
                                                               'data'       => $data));

         if (!($this->CORE->IsError($update_clause))) {

              $sql = $update_clause . " WHERE id=" . $this->CORE_DB->quote($app . '.' . $info['dest']);


              $result = $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                     'table' => 'core_settings'));

         } // End of if statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. Settings have been imported.  You can now continue 
            through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Media();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Media                                             |
// +------------------------------------------------------------------+

function step_Media () {

// +--
// | Importer Function Step: 
// |
// | Media File Import
// +--

$this->CORE->globals('importer.step','3');
$this->CORE->globals('importer.steptext','Media File Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import media files from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Media File Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import media files from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the media files from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MediaP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MediaP                                            |
// +------------------------------------------------------------------+

function step_MediaP () {

// +--
// | Importer Function Step: 
// |
// | Media File Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing media files.  No 
                 files have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustAcct();

} // End of if statement.

// +--
// | Handle importing the data.
// +--

$app         = $this->CORE->globals('core_cgi.import_destapp');

$dirdlsrc    = $this->CORE->globals('core_cgi.import_dirdata')  . '/downloads';
$dirimgs     = $this->CORE->globals('core_cgi.import_dirmedia') . '/images';
$destdlsrc   = $this->CORE->globals('core.path_private') . '/downloads';
$destimgs    = $this->CORE->globals('core.path_public') . '/media';

$translation = array($dirdlsrc                      => $destdlsrc,
                     $dirimgs . '/category'         => $destimgs . '/ecom/cat',
                     $dirimgs . '/product_category' => $destimgs . '/ecom/prodsm',
                     $dirimgs . '/product_detail'   => $destimgs . '/ecom/prodlg',
                     $dirimgs . '/product_xlarge'   => $destimgs . '/ecom/prodxl',
                     $dirimgs . '/site'             => $destimgs . '/cms/html',
                     $dirimgs . '/store'            => $destimgs . '/cms/html',
                     $dirimgs . '/banner'           => $destimgs . '/cms/html');

$this->CORE_File->make_dir($destimgs . '/cms/html');

foreach ($translation as $source => $dest) {

     $files  = array();

     $handle = @opendir($source);

     if (!(empty($handle))) {

          while (false !== ($file = @readdir($handle))) {

               if (($file != 'dir.txt') && ($file != 'index.htm') && ($file != 'default.htm') && (is_file($source . '/' . $file))) {

                    if (!(file_exists($dest . '/' . $file))) {

                         $this->CORE_File->copy(array('source' => $source . '/' . $file,
                                                      'dest'   => $dest . '/' . $file));

                    } // End of if statement.

               } // End of if statement.

          } // End of while statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. Media files have been imported.  You can now continue 
            through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_CustAcct();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcct                                          |
// +------------------------------------------------------------------+

function step_CustAcct () {

// +--
// | Importer Function Step: 
// |
// | Customer Account Import
// +--

$this->CORE->globals('importer.step','4');
$this->CORE->globals('importer.steptext','Customer Account Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import customer accounts from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Customer Account Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import customer accounts from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the customer accounts from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CustAcctP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcctP                                         |
// +------------------------------------------------------------------+

function step_CustAcctP () {

// +--
// | Importer Function Step: 
// |
// | Customer Account Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing customer accounts.  No 
                 accounts have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('custacct',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CustAcctP';
$mtinfo['currtask']   = 'Customer Account Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('custacct',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']               = array('source' => 'custacct_id', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['password']         = array('source' => 'custacct_pass', 'filter' => 'password', 'dvalue' => '');
     $translation['usergroup']        = array('source' => 'users', 'filter' => '', 'dvalue' => 'users');
     $translation['fname']            = array('source' => 'custacct_firstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']            = array('source' => 'custacct_lastname', 'filter' => '', 'dvalue' => '');
     $translation['lastaccess']       = array('source' => 'custacct_epoch', 'filter' => '', 'dvalue' => '');
     $translation['company']          = array('source' => 'custacct_company', 'filter' => '', 'dvalue' => '');
     $translation['phone']            = array('source' => 'custacct_phone', 'filter' => '', 'dvalue' => '');
     $translation['fax']              = array('source' => 'custacct_fax', 'filter' => '', 'dvalue' => '');
     $translation['addone']           = array('source' => 'custacct_addressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']           = array('source' => 'custacct_addresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']             = array('source' => 'custacct_city', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']        = array('source' => 'custacct_stateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']          = array('source' => 'custacct_country', 'filter' => '', 'dvalue' => '');
     $translation['postalcode']       = array('source' => 'custacct_zip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']           = array('source' => 'custacct_rescom', 'filter' => '', 'dvalue' => '');
     $translation['subscriptions']    = array('source' => '', 'filter' => '', 'dvalue' => '1');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Address book
          // +--

          if (!(empty($row['custacct_shipfirstname']))) {

               $addbook = array();

               $xbook = array('fname'      => $row['custacct_shipfirstname'],
                              'lname'      => $row['custacct_shiplastname'],
                              'company'    => $row['custacct_shipcompany'],
                              'addone'     => $row['custacct_shipaddressone'],
                              'addtwo'     => $row['custacct_shipaddresstwo'],
                              'city'       => $row['custacct_shipcity'],
                              'stateprov'  => $row['custacct_shipstateprov'],
                              'country'    => $row['custacct_shipcountry'],
                              'postalcode' => $row['custacct_shipzip'],
                              'rescom'     => $row['custacct_shiprescom']);

               $hash           = md5(serialize($xbook));
               $addbook[$hash] = $xbook;
               $addbook        = serialize($addbook);

               $insert['addbook'] = $addbook;

          } // End of if statement.

          // +--
          // | SPECIAL: Username field - autocalculated.
          // +--

          $insert['username'] = $this->CORE->random_number(10);

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'core_users',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'core_users'));

          } // End of if statement.


     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Customer accounts have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Affiliates                                        |
// +------------------------------------------------------------------+

function step_Affiliates () {

// +--
// | Importer Function Step: 
// |
// | Affiliate Account Import
// +--

$this->CORE->globals('importer.step','5');
$this->CORE->globals('importer.steptext','Affiliate Account Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import affiliate accounts from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Affiliate Account Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import affiliate accounts from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the affiliate accounts from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'AffiliatesP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_AffiliatesP                                       |
// +------------------------------------------------------------------+

function step_AffiliatesP () {

// +--
// | Importer Function Step: 
// |
// | Affiliate Account Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing affiliate accounts. 
                 No accounts have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('affacct',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'AffiliatesP';
$mtinfo['currtask']   = 'Affiliate Account Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('affacct',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']               = array('source' => 'affacct_email', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['password']         = array('source' => 'affacct_pass', 'filter' => 'password', 'dvalue' => '');
     $translation['usergroup']        = array('source' => '', 'filter' => '', 'dvalue' => 'affiliate');
     $translation['fname']            = array('source' => 'affacct_firstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']            = array('source' => 'affacct_lastname', 'filter' => '', 'dvalue' => '');
     $translation['lastaccess']       = array('source' => '', 'filter' => '', 'dvalue' => $this->CORE->globals('core_datetime.epoch'));
     $translation['company']          = array('source' => 'affacct_company', 'filter' => '', 'dvalue' => '');
     $translation['phone']            = array('source' => 'affacct_phone', 'filter' => '', 'dvalue' => '');
     $translation['fax']              = array('source' => 'affacct_fax', 'filter' => '', 'dvalue' => '');
     $translation['addone']           = array('source' => 'affacct_addressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']           = array('source' => 'affacct_addresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']             = array('source' => 'affacct_city', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']        = array('source' => 'affacct_stateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']          = array('source' => 'affacct_country', 'filter' => '', 'dvalue' => '');
     $translation['postalcode']       = array('source' => 'affacct_zip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']           = array('source' => 'affacct_rescom', 'filter' => '', 'dvalue' => '');
     $translation['subscriptions']    = array('source' => '', 'filter' => '', 'dvalue' => '1');
     $translation['affilid']          = array('source' => 'affacct_id', 'filter' => '', 'dvalue' => '');
     $translation['affilsalestodate'] = array('source' => 'affacct_salestd', 'filter' => '', 'dvalue' => '');
     $translation['affilcommearned']  = array('source' => 'affacct_commearntd', 'filter' => '', 'dvalue' => '');
     $translation['affilcommpaid']    = array('source' => 'affacct_commpaidtd', 'filter' => '', 'dvalue' => '');

     foreach ($data as $num => $row) {

          // +--
          // | Only do active affiliates.
          // +--

          if ($row['affacct_active'] == 'Y') {

               $insert = array();

               // +--
               // | STANDARD: Translated data
               // +--

               foreach ($translation as $key => $info) {

                    $insert[$key] = $row[$info['source']];

                    if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
                    if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

                    $insert[$key] = "{$insert[$key]}";

               } // End of foreach statement.

               // +--
               // | SPECIAL: Username field - autocalculated.
               // +--

               $insert['username'] = $this->CORE->random_number(10);

               // +--
               // | SPECIAL: Commission rate & commission owed
               // +--

               $insert['affilcommowed'] = $row['affacct_commearntd'] - $row['affacct_commpaidtd'];

               if ($insert['affilcommowed'] <= 0) {$insert['affilcommowed'] = '0.00';}

               if ($row['affacct_typemain'] == 'PCT') {$insert['affilcommpct'] = $row['affacct_valuemain'];}
               else                                   {$insert['affilcommpct'] = '0.000';}

               // +--
               // | Do a save.  This will update any existing user accounts with the new
               // | affiliate info.
               // +--

               $where = 'id=' . $this->CORE_DB->quote($insert['id']) . ' AND usergroup=' . $this->CORE_DB->quote('users');

               $this->CORE_DB->sql_save(array('table'  => 'core_users',
                                              'where'  => $where,
                                              'data'   => $insert,
                                              'update' => '*'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Affiliate accounts have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Maillist                                          |
// +------------------------------------------------------------------+

function step_Maillist () {

// +--
// | Importer Function Step: 
// |
// | Mail List Import
// +--

$this->CORE->globals('importer.step','6');
$this->CORE->globals('importer.steptext','Mail List Subscriber Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import mail list subscribers from 
your {$software} installation.  If you choose to import mail list subscribers, 
customer accounts will be created for them and random passwords will be assigned 
to each account created.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Mail List Subscriber Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import mail list subscribers from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the mail list subscribers from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MaillistP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MaillistP                                         |
// +------------------------------------------------------------------+

function step_MaillistP () {

// +--
// | Importer Function Step: 
// |
// | Mail List Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing mail list subscribers. 
                 No subscribers have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('maillist',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'MaillistP';
$mtinfo['currtask']   = 'Mail List Subscriber Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('maillist',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']               = array('source' => 'maillist_id', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['usergroup']        = array('source' => 'users', 'filter' => '', 'dvalue' => 'users');
     $translation['fname']            = array('source' => 'maillist_fname', 'filter' => '', 'dvalue' => '');
     $translation['lname']            = array('source' => 'maillist_lname', 'filter' => '', 'dvalue' => '');
     $translation['lastaccess']       = array('source' => '', 'filter' => '', 'dvalue' => $this->CORE->globals('core_datetime.epoch'));
     $translation['subscriptions']    = array('source' => '', 'filter' => '', 'dvalue' => '1');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Username field - autocalculated.
          // +--

          $insert['username'] = $this->CORE->random_number(10);

          // +--
          // | SPECIAL: Password
          // +--

          $insert['password'] = md5($this->CORE->random_key(8));

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => 'core_users',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'core_users'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Mail list subscribers have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Category                                          |
// +------------------------------------------------------------------+

function step_Category () {

// +--
// | Importer Function Step: 
// |
// | Online Store Category Import
// +--

$this->CORE->globals('importer.step','7');
$this->CORE->globals('importer.steptext','Online Store Category Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store categories 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Category Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store categories from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store categories from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CategoryP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CategoryP                                         |
// +------------------------------------------------------------------+

function step_CategoryP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Category Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store categories. 
                 No categories have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

// +--
// | Define the destination component.
// +--

$app  = $this->CORE->globals('core_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('category',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CategoryP';
$mtinfo['currtask']   = 'Online Store Category Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('category',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']           = array('source' => 'category_id', 'filter' => '', 'dvalue' => '');
     $translation['name']         = array('source' => 'category_name', 'filter' => '', 'dvalue' => '');
     $translation['keywords']     = array('source' => 'category_name', 'filter' => '', 'dvalue' => '');
     $translation['description']  = array('source' => 'category_desc', 'filter' => '', 'dvalue' => '');
     $translation['catimg']       = array('source' => 'category_imgsm', 'filter' => '', 'dvalue' => '');
     $translation['splashdisp']   = array('source' => 'category_splashdisp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['subdispnum']   = array('source' => 'category_catcount', 'filter' => '', 'dvalue' => '');
     $translation['subdisptype']  = array('source' => '', 'filter' => '', 'dvalue' => 'default');
     $translation['proddispnum']  = array('source' => 'category_smcount', 'filter' => '', 'dvalue' => '');
     $translation['proddisptype'] = array('source' => '', 'filter' => '', 'dvalue' => 'default');
     $translation['catmulti']     = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['xcat']         = array('source' => 'category_xcat', 'filter' => '', 'dvalue' => '');
     $translation['catview']      = array('source' => '', 'filter' => '', 'dvalue' => 'A');
     $translation['catviewg']     = array('source' => '', 'filter' => '', 'dvalue' => '');

     $sort_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $insert['id'] = $this->fix_id($insert['id']);

          $col       = 'xcat';
          $xdata     = $this->CORE->make_list($insert[$col]);
          $insert[$col] = '';
          foreach ($xdata as $xnum => $xid) {$xid = $this->fix_id($xid); $insert[$col] .= $xid . ', ';}
          $insert[$col] = preg_replace('/ \,/','',$insert[$col]);

          // +--
          // | SPECIAL: Date/Time Stamp.
          // +--

          $insert['datetimestamp'] = $this->CORE->globals('core_datetime.epoch');

          // +--
          // | SPECIAL: PNG/GIF replacement for 'none.*'.
          // +--

          if ($row['category_imgsm'] == 'none.gif')    {$insert['catimg'] = 'none.png';}

          // +--
          // | SPECIAL: Handle tags in description.
          // +--

          $insert['description'] = $this->import_changetags($row['category_desc']);

          // +--
          // | SPECIAL: Sort Order
          // +--

          $sort_order++;

          $insert['sortorder'] = $sort_order;

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_cat',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $result = $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_cat'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store categories have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Product                                           |
// +------------------------------------------------------------------+

function step_Product () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Import
// +--

$this->CORE->globals('importer.step','8');
$this->CORE->globals('importer.steptext','Online Store Product Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store products 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Product Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store products from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store products from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProductP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProductP                                          |
// +------------------------------------------------------------------+

function step_ProductP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store products. 
                 No products have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

// +--
// | Define the destination component.
// +--

$app  = $this->CORE->globals('core_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('product',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProductP';
$mtinfo['currtask']   = 'Online Store Product Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('product',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']             = array('source' => 'product_id', 'filter' => '', 'dvalue' => '');
     $translation['name']           = array('source' => 'product_name', 'filter' => '', 'dvalue' => '');
     $translation['prodnum']        = array('source' => 'product_number', 'filter' => '', 'dvalue' => '');
     $translation['pricestatus']    = array('source' => 'product_pricestatus', 'filter' => '', 'dvalue' => '');
     $translation['regprice']       = array('source' => 'product_regprice', 'filter' => '', 'dvalue' => '');
     $translation['saleprice']      = array('source' => 'product_saleprice', 'filter' => '', 'dvalue' => '');
     $translation['volprice']       = array('source' => 'product_volprice', 'filter' => '', 'dvalue' => '');
     $translation['voltext']        = array('source' => 'product_voltext', 'filter' => '', 'dvalue' => '');
     $translation['recurprice']     = array('source' => 'product_recurprice', 'filter' => '', 'dvalue' => '');
     $translation['whlprice']       = array('source' => 'product_regprice', 'filter' => '', 'dvalue' => '');
     $translation['affilcomm']      = array('source' => '', 'filter' => '', 'dvalue' => '0.00');
     $translation['keywords']       = array('source' => 'product_keywords', 'filter' => '', 'dvalue' => '');
     $translation['lgdisp']         = array('source' => '', 'filter' => '', 'dvalue' => 'default');
     $translation['reldisptype']    = array('source' => '', 'filter' => '', 'dvalue' => 'default');
     $translation['reldispnum']     = array('source' => '', 'filter' => '', 'dvalue' => '1');
     $translation['prodmulti']      = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['imgsm']          = array('source' => 'product_imgsm', 'filter' => '', 'dvalue' => '');
     $translation['imglg']          = array('source' => 'product_imglg', 'filter' => '', 'dvalue' => '');
     $translation['imgxl']          = array('source' => 'product_imgxlg', 'filter' => '', 'dvalue' => '');
     $translation['splashdisp']     = array('source' => 'product_splashdisp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['newdisp']        = array('source' => 'product_new', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['specialsdisp']   = array('source' => 'product_special', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['bestselldisp']   = array('source' => 'product_bestsell', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['featuredisp']    = array('source' => 'product_splashdisp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['taxstateprov']   = array('source' => '', 'filter' => '', 'dvalue' => 'STANDARD');
     $translation['taxcountry']     = array('source' => '', 'filter' => '', 'dvalue' => 'STANDARD');
     $translation['taxclass']       = array('source' => '', 'filter' => '', 'dvalue' => 'STANDARD');
     $translation['useinv']         = array('source' => 'product_useinv', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['invlevel']       = array('source' => 'product_inv', 'filter' => '', 'dvalue' => '');
     $translation['minquan']        = array('source' => '','filter' => '', 'dvalue' => '0');
     $translation['maxquan']        = array('source' => '','filter' => '', 'dvalue' => '0');
     $translation['addemtext']      = array('source' => 'product_addemtext', 'filter' => '', 'dvalue' => '');
     $translation['delmethod']      = array('source' => 'product_delmethod', 'filter' => '', 'dvalue' => '');
     $translation['customship']     = array('source' => 'product_customship', 'filter' => '', 'dvalue' => '');
     $translation['dlfile']         = array('source' => 'product_dlfile', 'filter' => '', 'dvalue' => '');
     $translation['shiponename']    = array('source' => 'product_shiponename', 'filter' => '', 'dvalue' => '');
     $translation['shiponeprice']   = array('source' => 'product_shiponeprice', 'filter' => '', 'dvalue' => '');
     $translation['shiptwoname']    = array('source' => 'product_shiptwoname', 'filter' => '', 'dvalue' => '');
     $translation['shiptwoprice']   = array('source' => 'product_shiptwoprice', 'filter' => '', 'dvalue' => '');
     $translation['shipthreename']  = array('source' => 'product_shipthreename', 'filter' => '', 'dvalue' => '');
     $translation['shipthreeprice'] = array('source' => 'product_shipthreeprice', 'filter' => '', 'dvalue' => '');
     $translation['shiplocal']      = array('source' => 'product_shiplocal', 'filter' => '', 'dvalue' => '');
     $translation['shipint']        = array('source' => 'product_shipint', 'filter' => '', 'dvalue' => '');
     $translation['shiplength']     = array('source' => 'product_shiplength', 'filter' => '', 'dvalue' => '');
     $translation['shipwidth']      = array('source' => 'product_shipwidth', 'filter' => '', 'dvalue' => '');
     $translation['shipheight']     = array('source' => 'product_shipheight', 'filter' => '', 'dvalue' => '');
     $translation['shipweight']     = array('source' => 'product_shipweight', 'filter' => '', 'dvalue' => '');
     $translation['shipnumbox']     = array('source' => 'product_shipnumbox', 'filter' => '', 'dvalue' => '');
     $translation['shipstateprov']  = array('source' => 'product_shipstateprov', 'filter' => '', 'dvalue' => '');
     $translation['shipcountry']    = array('source' => 'product_shipcountry', 'filter' => '', 'dvalue' => '');
     $translation['shipzip']        = array('source' => 'product_shipzip', 'filter' => '', 'dvalue' => '');
     $translation['shipemail']      = array('source' => 'product_shipemail', 'filter' => '', 'dvalue' => '');
     $translation['xcat']           = array('source' => 'product_xcat', 'filter' => '', 'dvalue' => '');
     $translation['xprod']          = array('source' => 'product_xprod', 'filter' => '', 'dvalue' => '');
     $translation['xprodoptions']   = array('source' => 'product_xopt', 'filter' => '', 'dvalue' => '');
     $translation['prodview']       = array('source' => '', 'filter' => '', 'dvalue' => 'A');
     $translation['prodviewg']      = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['reviewsavg']     = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['reviewsnum']     = array('source' => '', 'filter' => '', 'dvalue' => '0');

     $sort_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $insert['id'] = $this->fix_id($insert['id']);

          $col       = 'xcat';
          $xdata     = $this->CORE->make_list($insert[$col]);
          $insert[$col] = '';
          foreach ($xdata as $xnum => $xid) {$xid = $this->fix_id($xid); $insert[$col] .= $xid . ', ';}
          $insert[$col] = preg_replace('/ \,/','',$insert[$col]);

          $col       = 'xprod';
          $xdata     = $this->CORE->make_list($insert[$col]);
          $insert[$col] = '';
          foreach ($xdata as $xnum => $xid) {$xid = $this->fix_id($xid); $insert[$col] .= $xid . ', ';}
          $insert[$col] = preg_replace('/ \,/','',$insert[$col]);


          $col       = 'xprodoptions';
          $xdata     = $this->CORE->make_list($insert[$col]);
          $insert[$col] = '';
          foreach ($xdata as $xnum => $xid) {$xid = $this->fix_id($xid); $insert[$col] .= $xid . ', ';}
          $insert[$col] = preg_replace('/ \,/','',$insert[$col]);


          // +--
          // | SPECIAL: Date/Time Stamp.
          // +--

          $insert['datetimestamp'] = $this->CORE->globals('core_datetime.epoch');

          // +--
          // | SPECIAL: Strip tags from product name.
          // +--

          $insert['name'] = strip_tags($row['product_name']);

          // +--
          // | SPECIAL: PNG/GIF replacement for 'none.*'.
          // +--

          if ($row['product_imgsm'] == 'none.gif')    {$insert['imgsm'] = 'none.png';}
          if ($row['product_imglg'] == 'none.gif')    {$insert['imglg'] = 'none.png';}
          if ($row['product_imgxlg'] == 'none.gif')   {$insert['imgxl'] = 'none.png';}

          // +--
          // | SPECIAL: Sort Order
          // +--

          $sort_order++;

          $insert['sortorder'] = $sort_order;

          // +--
          // | SPECIAL: Handle tags in long description.
          // +--

          $insert['desclong'] = $this->import_changetags($row['product_desclong']);

          // +--
          // | SPECIAL: Handle required fields.
          // +--

          if (empty($insert['saleprice']))      {$insert['saleprice']      = '0.00';}
          if (empty($insert['shiponeprice']))   {$insert['shiponeprice']   = '0.00';}
          if (empty($insert['shiptwoprice']))   {$insert['shiptwoprice']   = '0.00';}
          if (empty($insert['shipthreeprice'])) {$insert['shipthreeprice'] = '0.00';}
          if (empty($insert['customship']))     {$insert['customship']     = 'user';}
          if (empty($insert['lgdisp']))         {$insert['lgdisp']         = 'default';}
          if (empty($insert['reldisptype']))    {$insert['reldisptype']    = 'default';}
          if (empty($insert['reldispnum']))     {$insert['reldispnum']     = '1';}

          // +--
          // | SPECIAL: Strip tags in short description.
          // +--

          $insert['descshort'] = $this->import_changetags($row['product_descshort']);

          if (empty($insert['descshort'])) {$insert['descshort'] = $insert['desclong'];}

          $insert['descshort'] = strip_tags($insert['descshort']);

          // +--
          // | SPECIAL: UPSWEBAPI => UPSTOOLS
          // +--

          if ($insert['shiplocal'] == 'UPSWEBAPI') {$insert['shiplocal'] = 'UPSTOOLS';}
          if ($insert['shipint']   == 'UPSWEBAPI') {$insert['shipint']   = 'UPSTOOLS';}

          // +--
          // | SPECIAL: Index
          // +--

          $insert['prodidx'] = strtoupper(substr($insert['name'],0,1));

          if (preg_match('/^[\d]/',$insert['prodidx'])) {$insert['prodidx'] = 'A';}

          // +--
          // | SPECIAL: Sort Price
          // +--

          $insert['sortprice'] = intval($insert['regprice']); 

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_prod',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_prod'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store products have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOpt                                           |
// +------------------------------------------------------------------+

function step_ProdOpt () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Import
// +--

$this->CORE->globals('importer.step','9');
$this->CORE->globals('importer.steptext','Online Store Product Option Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store product options 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Product Option Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store product options from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store product options from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProdOptP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOptP                                          |
// +------------------------------------------------------------------+

function step_ProdOptP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store product options. 
                 No options have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

// +--
// | Define the destination component.
// +--

$app  = $this->CORE->globals('core_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Get all of the product option selection items.
// +--

$optionsel = $this->import_load_data('optionsel',$tabledefs,0,'ALL');

if (($this->CORE->IsError($optsel)) || (empty($optsel))) {$optsel = array();}

$fieldorder = 0;
$xsel       = array();

if (!(empty($optionsel))) {

     foreach ($optionsel as $num => $row) {

          $fieldorder++;

          $inventory = $row['optionsel_inv']; if (empty($inventory)) {$inventory = '0';}

          $pricechngreg = $row['optionsel_price']; if (empty($pricechngreg)) {$pricechngreg = '0.00';}

          if (($pricechngreg > 0) && ($row['optionsel_pricech'] == 'D')) {$pricechngreg = '-' . $pricechngreg;}
          elseif ($pricechngreg > 0)                                     {$pricechngreg = '+' . $pricechngreg;}

          $weightchng = $row['optionsel_weight']; if (empty($weightchng)) {$weightchng = '0.000';}

          if (($weightchng > 0) && ($row['optionsel_weightch'] == 'D')) {$weightchng = '-' . $weightchng;}
          elseif ($weightchng > 0)                                      {$weightchng = '+' . $weightchng;}

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $row['optionsel_option'] = $this->fix_id($row['optionsel_option']);
          $row['optionsel_id']     = $this->fix_id($row['optionsel_id']);

          $xsel[$row['optionsel_option']][] = array('id'           => $row['optionsel_option'] . '-' . $row['optionsel_id'],
                                                    'name'         => $row['optionsel_selname'],
                                                    'pricechngreg' => $pricechngreg,
                                                    'pricechngrec' => '0.00',
                                                    'pricechngwhl' => $pricechngreg,
                                                    'afflcommchng' => '0.00',
                                                    'weightchng'   => $weightchng,
                                                    'inventory'    => $inventory,
                                                    'downloadfile' => '',
                                                    'fieldorder'   => $fieldorder,
                                                    'taxstateprov' => 'STANDARD',
                                                    'taxcountry'   => 'STANDARD',
                                                    'taxclass'     => 'STANDARD');

     } // End of foreach statement.

} // End of foreach statement.

$optionsel = $xsel; unset($xsel);

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('optionprod',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProdOptP';
$mtinfo['currtask']   = 'Online Store Product Option Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('optionprod',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id'] = array('source' => 'optionprod_id', 'filter' => '', 'dvalue' => '');
     $translation['name'] = array('source' => 'optionprod_name', 'filter' => '', 'dvalue' => '');
     $translation['required'] = array('source' => 'optionprod_required', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['useinventory'] = array('source' => 'optionprod_inv', 'filter' => 'yn2bool', 'dvalue' => '');

     $sort_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Fix ids.
          // +--

          $insert['id'] = $this->fix_id($insert['id']);

          // +--
          // | SPECIAL: Option section.
          // +--

          $insert['section'] = 'Item Options';

          // +--
          // | SPECIAL: Handle tags in description.
          // +--

          $insert['description'] = $this->import_changetags($row['optionprod_descript']);

          // +--
          // | SPECIAL: Field Order
          // +--

          $sort_order++;

          $insert['fieldorder'] = $sort_order;

          // +--
          // | SPECIAL: Field Type
          // +--

          $field_type = 'TEXTBOX-REG';

          if     ($row['optionprod_display_type'] == 'TEXTBOX')     {$field_type = 'TEXTBOX-REG';}
          elseif ($row['optionprod_display_type'] == 'TEXTAREA')    {$field_type = 'TEXTAREA-SMALL';}
          elseif ($row['optionprod_display_type'] == 'RADIO')       {$field_type = 'RADIO-CUSTOM';}
          elseif ($row['optionprod_display_type'] == 'SELECT')      {$field_type = 'SELECT-CUSTOM';}
          elseif ($row['optionprod_display_type'] == 'SELECT-MULT') {$field_type = 'CHECKBOX-CUSTOM';}
          elseif ($row['optionprod_display_type'] == 'CHECKBOX')    {$field_type = 'CHECKBOX-CUSTOM';}

          $insert['fieldtype'] = $field_type;

          // +--
          // | SPECIAL: Option Selection Items - Build them out here.
          // +--

          $insert['xprodoptionsel'] = '';

          if (!(empty($optionsel[$insert['id']]))) {

               foreach ($optionsel[$insert['id']] as $xnum => $xrow) {

                    $insert['xprodoptionsel'] .= $this->fix_id($xrow['id']) . ', ';

                    $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_prodoptionsel',
                                                               'data'  => $xrow));

                    if (!($this->CORE->IsError($sql))) {

                         $this->CORE_DB->sql_do(array('sql'   => $sql,
                                                      'table' =>  $app . '_prodoptionsel'));

                    } // End of if statement.

               } // End of foreach statement.

               if (preg_match('/, $/',$insert['xprodoptionsel'])) {$insert['xprodoptionsel'] = rtrim($insert['xprodoptionsel'],', ');}

          } // End of if statement.

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_prodoptions',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_prodoptions'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store product options have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Orders                                            |
// +------------------------------------------------------------------+

function step_Orders () {

// +--
// | Importer Function Step: 
// |
// | Orders Import
// +--

$this->CORE->globals('importer.step','10');
$this->CORE->globals('importer.steptext','Orders Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import orders 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Orders Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Orders from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the orders from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'OrdersP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrdersP                                           |
// +------------------------------------------------------------------+

function step_OrdersP () {

// +--
// | Importer Function Step: 
// |
// | Orders Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Orders. 
                 No orders have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_OrderItems();

} // End of if statement.

// +--
// | Define the destination component.
// +--

$app  = $this->CORE->globals('core_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('tracking',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'OrdersP';
$mtinfo['currtask']   = 'Orders Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('tracking',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']                 = array('source' => 'tracking_id', 'filter' => '', 'dvalue' => '');
     $translation['sessionid']          = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['status']             = array('source' => 'tracking_status', 'filter' => '', 'dvalue' => '');
     $translation['ordertotal']         = array('source' => 'tracking_total', 'filter' => 'priceround', 'dvalue' => '');
     $translation['recurtotal']         = array('source' => 'tracking_recurtotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['taxsptotal']         = array('source' => 'tracking_stateprovtax', 'filter' => 'priceround', 'dvalue' => '');
     $translation['taxctotal']          = array('source' => 'tracking_countrytax', 'filter' => 'priceround', 'dvalue' => '');
     $translation['taxcreftotal']       = array('source' => '', 'filter' => 'priceround', 'dvalue' => '0.00');
     $translation['custsaletotal']      = array('source' => 'tracking_saletotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['custsurchargetotal'] = array('source' => '', 'filter' => 'priceround', 'dvalue' => '0.00');
     $translation['disctotal']          = array('source' => 'tracking_discounttotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['shiptotal']          = array('source' => 'tracking_shippingtotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['commtotal']          = array('source' => '', 'filter' => 'priceround', 'dvalue' => '0.00');
     $translation['disccode']           = array('source' => 'tracking_discountcode', 'filter' => '', 'dvalue' => '');
     $translation['taxexemptnum']       = array('source' => 'tracking_othertax', 'filter' => '', 'dvalue' => '');
     $translation['disability']         = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['custsaledesc']       = array('source' => 'tracking_saledesc', 'filter' => '', 'dvalue' => '');
     $translation['custsurchargedesc']  = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['fname']              = array('source' => 'tracking_firstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']              = array('source' => 'tracking_lastname', 'filter' => '', 'dvalue' => '');
     $translation['phone']              = array('source' => 'tracking_phone', 'filter' => '', 'dvalue' => '');
     $translation['fax']                = array('source' => 'tracking_fax', 'filter' => '', 'dvalue' => '');
     $translation['email']              = array('source' => 'tracking_email', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['company']            = array('source' => 'tracking_company', 'filter' => '', 'dvalue' => '');
     $translation['addone']             = array('source' => 'tracking_addressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']             = array('source' => 'tracking_addresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']               = array('source' => 'tracking_city', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']          = array('source' => 'tracking_stateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']            = array('source' => 'tracking_country', 'filter' => '', 'dvalue' => '');
     $translation['postalcode']         = array('source' => 'tracking_zip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']             = array('source' => 'tracking_rescom', 'filter' => '', 'dvalue' => '');
     $translation['customone']          = array('source' => 'tracking_customone', 'filter' => '', 'dvalue' => '');
     $translation['customtwo']          = array('source' => 'tracking_customtwo', 'filter' => '', 'dvalue' => '');
     $translation['customthree']        = array('source' => 'tracking_customthree', 'filter' => '', 'dvalue' => '');
     $translation['customfour']         = array('source' => 'tracking_customfour', 'filter' => '', 'dvalue' => '');
     $translation['customfive']         = array('source' => 'tracking_customfive', 'filter' => '', 'dvalue' => '');
     $translation['customsix']          = array('source' => 'tracking_customsix', 'filter' => '', 'dvalue' => '');
     $translation['customseven']        = array('source' => 'tracking_customseven', 'filter' => '', 'dvalue' => '');
     $translation['customeight']        = array('source' => 'tracking_customeight', 'filter' => '', 'dvalue' => '');
     $translation['customnine']         = array('source' => 'tracking_customnine', 'filter' => '', 'dvalue' => '');
     $translation['customten']          = array('source' => 'tracking_customten', 'filter' => '', 'dvalue' => '');
     $translation['postordaff']         = array('source' => 'tracking_updateaff', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postordinv']         = array('source' => 'tracking_updateinv', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postorddisc']        = array('source' => 'tracking_updatedisc', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postordqb']          = array('source' => 'tracking_accexp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postordpt']          = array('source' => 'tracking_accexp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postordsage']        = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['commentsint']        = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['commentsext']        = array('source' => 'tracking_comments', 'filter' => '', 'dvalue' => '');
     $translation['ipaddress']          = array('source' => 'tracking_ipadd', 'filter' => '', 'dvalue' => '');
     $translation['custsurchargetotal'] = array('source' => '', 'filter' => '', 'dvalue' => '0.00');
     $translation['taxcreftotal']       = array('source' => '', 'filter' => '', 'dvalue' => '0.00');
     $translation['loyaltypointstotal'] = array('source' => '', 'filter' => '', 'dvalue' => '0.00');

     $now  = $this->CORE->globals('core_datetime.epoch');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Create the subtotal.
          // +--

          $subtotal = $insert['ordertotal'] - $insert['taxsptotal'] - $insert['taxctotal'] + $insert['taxcreftotal'] - $insert['custsurchargetotal'] + $insert['custsaletotal'] + $insert['disctotal'] - $insert['shiptotal'];

          $insert['subtotal'] = $this->import_price_round($subtotal);

          // +--
          // | SPECIAL: Date Fields.
          // +--

          $insert['datemonth'] = preg_replace('/^(.*?)\/(.*?)\/(.*?)$/','\\1',$row['tracking_date']);
          $insert['dateday']   = preg_replace('/^(.*?)\/(.*?)\/(.*?)$/','\\2',$row['tracking_date']);
          $insert['dateyear']  = preg_replace('/^(.*?)\/(.*?)\/(.*?)$/','\\3',$row['tracking_date']);

          // +--
          // | SPECIAL: Epoch.
          // +--

          $insert['epochorder'] = $now;

          // +--
          // | SPECIAL: Payment Method
          // +--

          $insert['paymethod'] = preg_replace('/^ste\_gw\_/','',$row['tracking_paymethod']);

          // +--
          // | SPECIAL: Referer.
          // +--

          $insert['referrer'] = $row['tracking_refurl'];

          if (!(empty($row['tracking_affiliate']))) {$insert['referrer'] = $row['tracking_affiliate'];}

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_orders',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_orders'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Orders have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_OrderItems();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrderItems                                        |
// +------------------------------------------------------------------+

function step_OrderItems () {

// +--
// | Importer Function Step: 
// |
// | Online Order Items Import
// +--

$this->CORE->globals('importer.step','11');
$this->CORE->globals('importer.steptext','Online Order Items Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online order items 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Order Items Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Online Order Items from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online order items from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'OrderItemsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrderItemsP                                       |
// +------------------------------------------------------------------+

function step_OrderItemsP () {

// +--
// | Importer Function Step: 
// |
// | Online Order Items Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Online Order Items. 
                 No online order items have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

// +--
// | Define the destination component.
// +--

$app  = $this->CORE->globals('core_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('trackitem',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'OrderItemsP';
$mtinfo['currtask']   = 'Online Order Items Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('trackitem',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['orderid']    = array('source' => 'trackitem_tracknum', 'filter' => '', 'dvalue' => '');
     $translation['shipstatus'] = array('source' => 'trackitem_shipstatus', 'filter' => '', 'dvalue' => '');
     $translation['shipmethod'] = array('source' => 'trackitem_shipmethod', 'filter' => '', 'dvalue' => '');
     $translation['itemname']   = array('source' => 'trackitem_itemname', 'filter' => '', 'dvalue' => '');
     $translation['itemnum']    = array('source' => 'trackitem_itemnumber', 'filter' => '', 'dvalue' => '');
     $translation['itemid']     = array('source' => 'trackitem_cartprodid', 'filter' => '', 'dvalue' => '');
     $translation['itemquan']   = array('source' => 'trackitem_quantity', 'filter' => '', 'dvalue' => '');
     $translation['itemopts']   = array('source' => 'trackitem_options', 'filter' => '', 'dvalue' => '');
     $translation['ordertotal'] = array('source' => 'trackitem_prodtotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['recurtotal'] = array('source' => 'trackitem_recur', 'filter' => 'priceround', 'dvalue' => '');
     $translation['fname']      = array('source' => 'trackitem_shipfirstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']      = array('source' => 'trackitem_shiplastname', 'filter' => '', 'dvalue' => '');
     $translation['company']    = array('source' => 'trackitem_shipcompany', 'filter' => '', 'dvalue' => '');
     $translation['addone']     = array('source' => 'trackitem_shipaddressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']     = array('source' => 'trackitem_shipaddresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']       = array('source' => 'trackitem_shipcity', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']  = array('source' => 'trackitem_shipstateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']    = array('source' => 'trackitem_shipcountry', 'filter' => '', 'dvalue' => '');
     $translation['postalcode'] = array('source' => 'trackitem_shipzip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']     = array('source' => 'trackitem_shiprescom', 'filter' => '', 'dvalue' => '');

     $now  = $this->CORE->globals('core_datetime.epoch');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Create the ID.
          // +--

          $insert['id'] = $insert['orderid'] . '-' . $row['trackitem_id'];

          // +--
          // | SPECIAL: Epoch.
          // +--

          $insert['epochorder'] = $now;

          // +--
          // | SPECIAL: Cart Data.
          // +--

          $insert['cartdata'] = serialize(array());

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_orderitems',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_orderitems'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online order items have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Discounts                                         |
// +------------------------------------------------------------------+

function step_Discounts () {

// +--
// | Importer Function Step: 
// |
// | Discount Code Import
// +--

$this->CORE->globals('importer.step','12');
$this->CORE->globals('importer.steptext','Discount Code Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import discount codes 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Discount Code Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Discount Codes from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the discount codes from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DiscountsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DiscountsP                                        |
// +------------------------------------------------------------------+

function step_DiscountsP () {

// +--
// | Importer Function Step: 
// |
// | Discount Code Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Discount Codes. 
                 No discount codes have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

// +--
// | Define the destination component.
// +--

$app  = $this->CORE->globals('core_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('discount',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DiscountsP';
$mtinfo['currtask']   = 'Discount Code Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('discount',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']        = array('source' => 'discount_id', 'filter' => '', 'dvalue' => '');
     $translation['prodlimit'] = array('source' => 'discount_limitprod', 'filter' => '', 'dvalue' => '');
     $translation['xprod']     = array('source' => 'discount_xprod', 'filter' => '', 'dvalue' => '');
     $translation['active']    = array('source' => 'discount_active', 'filter' => 'yn2bool', 'dvalue' => '');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Related Products
          // +--

          $col       = 'xprod';
          $xdata     = $this->CORE->make_list($insert[$col]);
          $insert[$col] = '';
          foreach ($xdata as $xnum => $xid) {$xid = $this->fix_id($xid); $insert[$col] .= $xid . ', ';}
          $insert[$col] = preg_replace('/ \,/','',$insert[$col]);

          // +--
          // | SPECIAL: Shipping charges included.
          // +--

          $insert['inclship'] = '0';

          // +--
          // | SPECIAL: Code Type
          // +--

          $insert['codetype'] = 1;

          if ($row['discount_type'] == '5') {$insert['codetype'] = 5;}

          // +--
          // | SPECIAL: Code Value
          // +--

          $insert['codevalue'] = $this->import_price_round($row['discount_value']);

          if ($row['discount_currpct'] == 'PCT') {$insert['codevalue'] .= '0%';}

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_discounts',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_discounts'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Discount codes have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPage                                          |
// +------------------------------------------------------------------+

function step_HtmlPage () {

// +--
// | Importer Function Step: 
// |
// | HTML Page Import
// +--

$this->CORE->globals('importer.step','13');
$this->CORE->globals('importer.steptext','HTML Page Import');

// +--
// | Print the form.
// +--

$this->CORE->globals('core_cgi.import_do','0');

$software = $this->CORE->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import HTML pages 
from your {$software} installation.  HTML pages imported are of the 
user-defined type.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'HTML Page Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import HTML Pages from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the HTML pages from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'HtmlPageP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPageP                                         |
// +------------------------------------------------------------------+

function step_HtmlPageP () {

// +--
// | Importer Function Step: 
// |
// | HTML Page Import - Process
// +--

// +--
// | Make sure required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->CORE->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing HTML Pages. 
                 No HTML pages have been imported.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Final();

} // End of if statement.

// +--
// | Define the destination component.
// +--

$app  = 'cms';

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->CORE->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->CORE->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->CORE->globals('core_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('htmlpage',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'HtmlPageP';
$mtinfo['currtask']   = 'HTML Page Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->CORE->globals('core_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('htmlpage',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']           = array('source' => 'htmlpage_id', 'filter' => '', 'dvalue' => '');
     $translation['dispname']     = array('source' => 'htmlpage_name', 'filter' => '', 'dvalue' => '');
     $translation['menudisp']     = array('source' => '', 'filter' => '', 'dvalue' => '1');
     $translation['titledisp']    = array('source' => 'htmlpage_usetitleimg', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['metatitle']    = array('source' => 'htmlpage_name', 'filter' => '', 'dvalue' => '');
     $translation['metakeywords'] = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['metadesc']     = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['htmlview']     = array('source' => '', 'filter' => '', 'dvalue' => 'A');
     $translation['htmlviewg']    = array('source' => '', 'filter' => '', 'dvalue' => '');

     $menu_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if ((!(empty($info['dvalue']))) || ($info['dvalue'] === '0')) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: HTML Content
          // +--

          $insert['htmlcontent'] = '';

          $result = $this->CORE_File->read($this->CORE->globals('core_cgi.import_dirdata') . '/elements/' . $insert['id'] . '.txt');

          if (!($this->CORE->IsError($result))) {$insert['htmlcontent'] = $result;}

          $insert['htmlcontent'] = $this->import_changetags($insert['htmlcontent']);

          // +--
          // | SPECIAL: Menu Order
          // +--

          $menu_order++;

          $insert['menuorder'] = $menu_order;

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->CORE_DB->clause_insert(array('table' => $app . '_html',
                                                     'data'  => $insert));

          if (!($this->CORE->IsError($sql))) {

               $this->CORE_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_html'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. HTML pages have been imported.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Final();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Final                                             |
// +------------------------------------------------------------------+

function step_Final () {

// +--
// | Importer Function Step.
// +--

// +--
// | Define variables for the confirm display.
// +--

$link     = $this->CORE->globals('core.script_backend');

// +--
// | Final Confirm Display
// +--

print <<<ENDOFTEXT

<p>The data import process has completed.  The data you chose to import 
has been saved to the primary database connection and the 
filesystem used by this software.</p>

<p><a href="{$link}" title="Management Interface">Click here to run 
the Management Interface.</a></p>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Display                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: disp                                                   |
// +------------------------------------------------------------------+

function disp () {

// +--
// | This function displays the importer screen output.
// +--

// +--
// | Define our date for our copyright and our EOL.
// +--

$date_year = @date('Y');
$eol       = $this->CORE->globals('core.eol');

$title_add = '';

if ($this->CORE->globals('importer.steptext')) {

     $title_add = ' - ' . $this->CORE->xhtml_translate($this->CORE->globals('importer.steptext'),'ENCODE');

} // End of if statement.

// +--
// | Print the header section.
// +--

print <<<ENDOFTEXT

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 

<style type="text/css" media="all">

body {
     font-family: Verdana, Tahoma, Arial, sans-serif;
     font-size: 11px;
     color: #333333;
     font-weight: normal;
     text-align: left;
     background-color: #F5F5F5;
     margin: 20px;
     font-size: 12px;
     }

a {
     color: #30569D;
     text-decoration: underline;
     font-weight: normal;
     }

a:hover {
     color: #333333;
     text-decoration: underline;
     }

.strong {
     font-weight: bold;
     }

fieldset {
     border: none;
     padding: 0px;
     margin-bottom: 15px;
     }

legend {
     display: none;
     }


label {
     display: none;
     }

fieldset p {
     display: block;
     margin: 0px 0px 8px 0px;
     }

#header {
     border-top: 1px solid #333333;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     width: 620px;
     padding: 0px;
     margin: 0px auto 0px auto;
     background-image: url('//central.kryptronic.com/public/media/header_europacart.png');
     background-position: top left;
     background-repeat: no-repeat;
     height: 50px;
     -moz-border-radius: 8px 8px 0px 0px;
     -webkit-border-radius: 8px 8px 0px 0px;
     border-radius: 8px 8px 0px 0px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     }

#content {
     color: #333333;
     background-color: #FFFFFF;
     border-bottom: 1px solid #333333;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: auto;
     -moz-border-radius: 0px 0px 8px 8px;
     -webkit-border-radius: 0px 0px 8px 8px;
     border-radius: 0px 0px 8px 8px;
     -moz-box-shadow: 2px 2px 2px #333333;
     -webkit-box-shadow: 2px 2px 2px #333333;
     box-shadow: 2px 2px 2px #333333;
     line-height: 1.25em;
     }

#pgtitle {
     color: #4E70AE;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     font-weight: bold;
     font-size: 18px;
     }

.formfieldleg {
     border-top: 1px solid #DEDEDE;
     padding-top: 10px;
     font-weight: bold;
     }

.formfieldinstruct {
     color: #30569D;
     font-size: 11px;
     margin: 5px 0px 5px 0px;
     }

#meter {
     width: auto;
     margin: 20px 0px 10px 0px;
     }

p.meter {
     color: #333333;
     display: inline;
     }

p.metercomp {
     background-color: #339933;
     color: #339933;
     display: inline;
     font-weight: bold;
     padding: 5px 0px 5px 0px;
     }

p.meterpend {
     background-color: #CCCCCC;
     color: #CCCCCC;
     display: inline;
     font-weight: bold;
     padding: 5px 0px 5px 0px;
     }

.msgerror {
     color: #FF0000;
     font-weight: bold;
     }

.msgconf {
     color: #339933;
     font-weight: bold;
     }

.hidden {
     display: none;
     }

.formfieldradcb {
     color: inherit;
     background-color: inherit;
     margin-bottom: 4px;
     border: none;
     }

.formfield {
     background-color: #FFFFFF;
     border: 1px solid #8C867B;
     margin: 5px 5px 0px 0px;
     font-family: Arial, Helvetica, sans-serif;
     font-size: 12px;
     padding: 2px;
     }

.formfield:focus {
     background-color: #FFFFDD;
     border: 1px solid #FFCC66;
     }

select.formfield {
     -moz-border-radius: 6px 0px 0px 6px;
     -webkit-border-radius: 6px 0px 0px 6px;
     border-radius: 6px 0px 0px 6px;
     }

input.formfield, textarea.formfield {
     -moz-border-radius: 6px 6px 6px 6px;
     -webkit-border-radius: 6px 6px 6px 6px;
     border-radius: 6px 6px 6px 6px;
     }

.formbutton {
     color: #333333;
     background-color: #DEDEDE;
     padding: 1px;
     margin-top: 5px;
     margin-left: 2px;
     font-weight: bold;
     width: 100px;
     font-size: 11px;
     border: 1px solid #333333;
     -moz-border-radius: 6px 6px 6px 6px;
     -webkit-border-radius: 6px 6px 6px 6px;
     border-radius: 6px 6px 6px 6px;
     }

.formbutton:hover {
     color: #333333;
     background-color: #EFEFEF;
     -moz-border-radius: 6px 6px 6px 6px;
     -webkit-border-radius: 6px 6px 6px 6px;
     border-radius: 6px 6px 6px 6px;
     }

</style>

<title>Software Data Importer{$title_add}</title>

<script type="text/javascript" src="//central.kryptronic.com/public/jquery/jquery.min.js"></script>
<script type="text/javascript">jQuery.noConflict();</script>

<script type="text/javascript">

jQuery(document).ready(function(){

     jQuery('input:submit').click(function(){

          if (jQuery(this).prop('value') == 'Cancel') {return true;}

          if (jQuery(this).hasClass('disabled')) {return false;}

          jQuery(this).addClass('disabled');

          jQuery(this).prop('value','Please Wait...');

          return true;

     });

ENDOFTEXT;

if ($this->CORE->globals('importer.auto_submit')) {print '     jQuery(\'#importer\').submit();' . $eol;}

print <<<ENDOFTEXT

     jQuery('a[rel=\'external\']').prop('target', '_blank');

});

jQuery(window).unload(function() {

     jQuery('input:submit').removeClass('disabled');

});

</script>

</head>

<body>

<div id="header">&nbsp;</div>

<div id="content">

ENDOFTEXT;

// +--
// | Print the page header section.
// +--

$step     = $this->CORE->xhtml_translate($this->CORE->globals('importer.step'),'ENCODE');
$steptext = $this->CORE->xhtml_translate($this->CORE->globals('importer.steptext'),'ENCODE');
$numsteps = $this->CORE->xhtml_translate($this->CORE->globals('importer.numsteps'),'ENCODE');

if (($step) && ($steptext)) {

     print '<div id="pgtitle">Step ' . $step . ' of ';
     print $numsteps . ': ' . $steptext;
     print '</div>' . $eol . $eol;

} else {

     print '<div id="pgtitle">Data Importer: ';
     print $this->CORE->xhtml_translate($this->CORE->globals('importer.name'),'ENCODE');
     print '</div>' . $eol . $eol;

} // End of if statement.

// +--
// | Print our content.
// +--

$content = $this->CORE->globals('importer.buffered_output');

print $content;

// +--
// | Print the page footer.
// +--

print <<<ENDOFTEXT

</div>

</body>

</html>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_message                                           |
// +------------------------------------------------------------------+

function disp_message ($message = '',$type = 'ERROR') {

// +--
// | This function prints a message.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | If message is blank, return true without printing anything.
// +--

if ($message == '') {return 1;}

// +--
// | Replace full directory paths in the message.
// +--

$pathpriv_quoted = preg_quote($this->CORE->globals('core.path_private'),'/');
$pathpub_quoted  = preg_quote($this->CORE->globals('core.path_public'),'/');

$message = preg_replace('/' . $pathpriv_quoted . '\//','/',$message);
$message = preg_replace('/' . $pathpub_quoted  . '\//','/',$message);

// +--
// | Encode the message.
// +--

$message = $this->CORE->xhtml_translate($message,'ENCODE');

// +--
// | Print the message.
// +--

if ($type == 'ERROR') {

     print '<p class="msgerror">' . $message . '</p>' . $eol . $eol;

} else {

     print '<p class="msgconf">' . $message . '</p>' . $eol . $eol;

} // End of if statement.

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: formdata_array                                         |
// +------------------------------------------------------------------+

function formdata_array ($input = array()) {

// +--
// | This function returns an array of formdata values.  It accepts
// | input in an array with the following format:
// |
// | key:   The formdata field.
// | value: Boolean indicating required status.
// |
// | This function will return an error object if any required fields
// | are not complete.
// +--

$result = array();

if (empty($input)) {return $result;}

$reqnotcomp = 0;

foreach ($input as $key => $value) {

     $xvalue = $this->CORE->globals('core_cgi.' . $key);

     if (!(isset($xvalue))) {$xvalue = '';}

     $result[$key] = $xvalue;

     if ((empty($result[$key])) && (!(empty($value)))) {$reqnotcomp++;}

} // End of foreach statement.

if ($reqnotcomp) {

     $message = "You did not complete all of the required fields before 
                 clicking the 'Continue' button.  Please try again.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return the result array.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_form                                              |
// +------------------------------------------------------------------+

function disp_form ($input = array()) {

// +--
// | This function prints an XHTML form to be used by the importer.
// | 
// | Input is accepted in the form of an array with the following
// | parameters:
// |
// | 'header'   => XHTML header
// |
// | 'step'     => The step to post to.
// |
// | 'supform'  => Optional boolean indicator.  If true the opening 
// |               <form> tag is supressed.  Useful if the header
// |               contains form fields.
// |
// | 'autosub'  => Optional indicator.  If value is 1 this form 
// |               will be auto-submitted.
// |
// | 'fields'   => An array of fields with the following array keys:
// |
// |               'id'       => Form field name.
// |
// |               'name'     => Field display name.
// |
// |               'type'     => Form field type (SELECT, RADIO, HIDDEN
// |                           CHECKBOX, TEXT-REG, TEXT-LONG, PASSWORD)
// |
// |               'desc'     => Pre-formatted XHTML description.
// |
// |               'values'   => An array of values (key = select value,
// |                             value = select display name) for a 
// |                             SELECT, CHECKBOX or RADIO field.
// |
// |               'value'    => A value to use for HIDDEN fields.
// |
// |               'required' => Boolean required indicator.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | Set up function variables.
// +--

$header  = (isset($input['header'])  ? $input['header']  : '');
$fields  = (isset($input['fields'])  ? $input['fields']  : array());
$step    = (isset($input['step'])    ? $input['step']    : 'Default');
$supform = (isset($input['supform']) ? $input['supform'] : 0);
$autosub = (isset($input['autosub']) ? $input['autosub'] : 0);

// +--
// | Handle the auto-submit form object.
// +--

if ($autosub == 1) {

     $this->CORE->globals('importer.auto_submit',1);

} // End of if statement.

// +--
// | Print the form header.
// +--

if ($header) {

     print $header . $eol . $eol;

} // End of if statement.

// +--
// | Print the <form> element and required info if not supressed.
// +--

if (empty($supform)) {

     $insname = $this->CORE->globals('importer.script_name');

     print '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

     print '<p>Required fields are marked with a star (*). ';

     if ($autosub == 1) {

          print 'This form should auto-submit itself.  If this does not occur, ';
          print 'click the \'Continue\' button at the bottom of ';
          print 'this page to proceed.</p>' . $eol . $eol;


     } else {

          print 'Click the \'Continue\' button at the bottom of ';
          print 'this page to proceed.</p>' . $eol . $eol;

     } // End of if statement.

} // End of if statement.

// +--
// | Get a list of all of the fields.
// +--

$seen = array();

foreach ($fields as $num => $field) {

     $id = (isset($field['id']) ? $field['id'] : '');

     $seen[$id] = 1;

} // End of foreach statement.

// +--
// | Print the HIDDEN form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     if ($type == 'HIDDEN') {

          $pid    = $this->CORE->xhtml_translate($id,'ENCODE');
          $pvalue = $this->CORE->xhtml_translate($value,'ENCODE');

          print '<p class="hidden"><input type="hidden" name="' . $pid . '" ';
          print 'id="' . $pid . '" value="' . $pvalue . '" /></p>' . $eol . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print the ALL OTHER form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     $req = ''; if ($required) {$req = '*';}

     $pvalue = $this->CORE->globals('core_cgi.' . $id); if (empty($pvalue)) {$pvalue = '';}

     $pid    = $this->CORE->xhtml_translate($id,'ENCODE');
     $pname  = $this->CORE->xhtml_translate($name,'ENCODE');

     $xpid   = $pid;

     if (($type == 'CHECKBOX') || ($xpid == 'RADIO')) {$xpid .= '--1';}

     if ($type != 'HIDDEN') {

          print '<fieldset>' . $eol . $eol;

          print '<legend class="strong"><label for="' . $xpid . '">' . $pname . $req;
          print '</label></legend>' . $eol . $eol;

          print '<p class="formfieldleg">' . $pname . $req . '</p>' . $eol . $eol;

          print '<div class="formfieldinstruct">' . $desc . '</div>' . $eol . $eol;

          if (($type == 'TEXT-REG') || ($type == 'TEXT-LONG') || ($type == 'PASSWORD')) {

               $pvalue = $this->CORE->xhtml_translate($pvalue,'ENCODE');

               $size  = '25';   if ($type == 'TEXT-LONG')  {$size = '50';}
               $xtype = 'text'; if ($type == 'PASSWORD')   {$xtype = 'password';}

               print '<input class="formfield" type="' . $xtype . '" ';

               if ($type == 'PASSWORD') {print 'autocomplete="off" ';}

               print 'name="' . $pid . '" id="' . $pid . '" value="';
               print $pvalue . '" size="' . $size . '" />' . $eol . $eol;

          } else {

               if (is_array($pvalue)) {$pvalue = array_flip($pvalue);} else {$pvalue = array($pvalue => 1);}

               if (!(empty($values))) {

                    $count   = 0;
                    $pvalues = array();

                    $made_checked = 0;

                    foreach ($values as $xkey => $xvalue) {

                         $count++;

                         $checked = 0; if (array_key_exists($xkey,$pvalue)) {$checked = 1; $made_checked = 1;}

                         $pvalues[] = array('value'   => $xkey,
                                            'display' => $this->CORE->xhtml_translate($xvalue,'ENCODE'),
                                            'checked' => $checked,
                                            'xid'     => $id . '--' . $count);

                    } // End of foreach statement.

                    if ((!($made_checked)) && ($type == 'RADIO')) {$pvalues[0]['checked'] = 1;}

                    if ($type == 'SELECT') {

                          print '<select class="formfield" name="' . $pid . '" id="' . $pid . '">' . $eol;

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' selected="selected"';}

                               print '<option value="' . $xv['value'] . '" ';
                               print $checked . '>' . $xv['display'] . '</option>' . $eol;

                          } // End of foreach statement.

                          print '</select>' . $eol . $eol;

                    } elseif ($type == 'CHECKBOX') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<p><input class="formfieldradcb" type="checkbox" name="' . $pid . '[]" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;

                          } // End of foreach statement.

                    } elseif ($type == 'RADIO') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<p><input class="formfieldradcb" type="radio" name="' . $pid . '" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;

                          } // End of foreach statement.

                    } // End of if statement.

               } // End of if statement.

          } // End of if statement.

          print '</fieldset>' . $eol . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print our license_agree, import_password and step fields
// | as well as other fields specific to this importer - if 
// | they weren't seen.
// +--

if (!(array_key_exists('license_agree',$seen))) {

     $value = $this->CORE->globals('core_cgi.license_agree');

     if (is_array($value)) {$value = 1;}

     $value = $this->CORE->xhtml_translate($value,'ENCODE');

     print '<p class="hidden"><input type="hidden" name="license_agree" ';
     print 'id="license_agree" value="' . $value . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_password',$seen))) {

     $value = $this->CORE->xhtml_translate($this->CORE->globals('core_cgi.import_password'),'ENCODE');

     print '<p class="hidden"><input type="hidden" name="import_password" ';
     print 'id="import_password" value="' . $value . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('step',$seen))) {

     print '<p class="hidden"><input type="hidden" name="step" ';
     print 'id="step" value="' . $step . '" /></p>' . $eol . $eol;

} // End of if statement.

if (($autosub == 1) && (!(array_key_exists('auto_submit',$seen)))) {

     print '<p class="hidden"><input type="hidden" name="auto_submit" ';
     print 'id="auto_submit" value="1" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_destapp',$seen))) {

     $import_destapp = $this->CORE->globals('core_cgi.import_destapp');
     if (empty($import_destapp)) {$import_destapp = '';}

     print '<p class="hidden"><input type="hidden" name="import_destapp" ';
     print 'id="import_destapp" value="' . $import_destapp . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_dirdata',$seen))) {

     $import_dirdata = $this->CORE->globals('core_cgi.import_dirdata');
     if (empty($import_dirdata)) {$import_dirdata = '';}

     print '<p class="hidden"><input type="hidden" name="import_dirdata" ';
     print 'id="import_dirdata" value="' . $import_dirdata . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_dirmedia',$seen))) {

     $import_dirmedia = $this->CORE->globals('core_cgi.import_dirmedia');
     if (empty($import_dirmedia)) {$import_dirmedia = '';}

     print '<p class="hidden"><input type="hidden" name="import_dirmedia" ';
     print 'id="import_dirmedia" value="' . $import_dirmedia . '" /></p>' . $eol . $eol;

} // End of if statement.

// +--
// | Print the form footer.
// +--

print <<<ENDOFTEXT

<p><input class="formbutton" type="submit" name="SUBMIT" id="SUBMIT" value="Continue" /></p>

</form>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Multi-Task Form Display                                          |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: do_multitask                                           |
// +------------------------------------------------------------------+

function do_multitask ($multitask = array()) {

// +--
// | This function presents a multi-task form.
// +--

$eol = $this->CORE->globals('core.eol');

// +--
// | Define our current task.
// +--

$current_task_text = $this->CORE->xhtml_translate($multitask['currtask'],'ENCODE');

// +--
// | Set up the progress bar.
// +--

$progress_bar = '';

$progress_bar_countt  = $multitask['ntaskcount'];
$progress_bar_counti  = $multitask['ntaskcurr'];
$progress_bar_disp    = 50;

$bars_disp= '';
$bars_leftdisp = '';
$bar_count= 0;

$pct = $progress_bar_counti / $progress_bar_countt;
$pct = round($pct,2);

$pct_disp = $pct * 100;

$bars = $progress_bar_disp * $pct;
$bars = round($bars);

while ($bar_count < $bars) {$bar_count++; $bars_disp .= '|';}

$bars_left = $progress_bar_disp - $bars;

$bar_count = 0;

while ($bar_count < $bars_left) {$bar_count++; $bars_leftdisp .= '|';}

$pct_leftdisp = 100 - $pct_disp;

$progress_bar  = '<p class="meter">Progress: </p>';

if ($bars) {$progress_bar .= '<p class="metercomp">' . $bars_disp . '</p>';}

if ($bars_left) {$progress_bar .= '<p class="meterpend">' . $bars_leftdisp . '</p>';}

$progress_bar .= '<p class="meter"> [' . $pct_disp . '%]</p>' . $eol . $eol;

$header = <<<ENDOFTEXT

<p>You have selected to process a multi-task operation.  If this page does 
not automatically refresh itself within one second, click the 'Continue' 
button to proceed.</p>

ENDOFTEXT;

$insname = $this->CORE->globals('importer.script_name');

$header .= '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

$header .= <<<ENDOFTEXT

<fieldset>

<legend class="strong"><label for="taskdo">Task Status</label></legend>

<p class="formfieldleg">Task Status</p>

<div class="formfieldinstruct">

<p>The progress meter below displays your progress during this multi-task operation.</p>

<div id='meter'>{$progress_bar}</div>

</div>

<p class="hidden"><input type="hidden" name="taskstatus" id="taskstatus" value="1" /></p>

</fieldset>

<fieldset>

<legend class="strong"><label for="currenttask">Current Task</label></legend>

<p class="formfieldleg">Task Status</p>

<div class="formfieldinstruct">

<p>{$current_task_text}</p>

</div>

<p class="hidden"><input type="hidden" name="currenttask" id="currenttask" value="1" /></p>

</fieldset>

ENDOFTEXT;

// +--
// | Formulate the form fields.
// +--

$fields[0]['id']       = 'offset';
$fields[0]['type']     = 'HIDDEN';
$fields[0]['required'] = 0;
$fields[0]['value']    = $multitask['offset'];

$fields[1]['id']       = 'import_do';
$fields[1]['type']     = 'HIDDEN';
$fields[1]['required'] = 0;
$fields[1]['value']    = 1;

if (!(empty($multitask['mtcomplete']))) {

     $fields[2]['id']       = 'mtcomplete';
     $fields[2]['type']     = 'HIDDEN';
     $fields[2]['required'] = 0;
     $fields[2]['value']    = 1;

} // End of if statement.

// +--
// | Print the form.
// +--

$this->disp_form(array('header'   => $header,
                       'fields'   => $fields,
                       'step'     => $multitask['currstep'],
                       'supform'  => 1,
                       'autosub'  => 1));

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Common Functions                                        |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: import_load_settings                                   |
// +------------------------------------------------------------------+

function import_load_settings ($filename = 'settings.csv') {

// +--
// | This function loads settings from the source install.
// +--

// +--
// | Load settings from the CSV file.
// +--

$settings_file = $this->CORE->globals('core_cgi.import_dirdata') . '/tables/' . $filename;

$settings = $this->CORE_File->parsecsv(array('filename' => $settings_file));

// +--
// | Handle errors.
// +--

if ($this->CORE->IsError($settings)) {

     $message  = "An error was encountered while attempting to retrieve  
                  settings from the source installation.  The error 
                  returned was: ";

     $message .= $settings->GetMessage();

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

if (empty($settings['data'])) {

     $message  = "An error was encountered while attempting to retrieve  
                  settings from the source installation.  No Settings were 
                  found.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Formulate our return array.
// +--

$colprefix = preg_replace('/\.csv$/','',$filename);

$settings_return = array();

foreach ($settings['data'] as $num => $row) {

     $settings_return[$row[$colprefix . '_id']] = $row[$colprefix . '_value'];

} // End of foreach statement.

// +--
// | Return the settings.
// +--

return $settings_return;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_tabledefs                                  |
// +------------------------------------------------------------------+

function import_load_tabledefs ($settings = array()) {

// +--
// | This function loads table definitions.  It creates an array
// | with table names as keys and the data source as values.
// +--

// +--
// | Return an error if we weren't passed settings.
// +--

if (empty($settings)) {

     $message  = "An error was encountered while attempting to retrieve  
                  table information from the source installation.  No 
                  settings information was supplied.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Load tables from the CSV file.
// +--

$tables_file = $this->CORE->globals('core_cgi.import_dirdata') . '/tables/tables.csv';

$tables = $this->CORE_File->parsecsv(array('filename' => $tables_file));

// +--
// | Handle errors.
// +--

if ($this->CORE->IsError($tables)) {

     $message  = "An error was encountered while attempting to retrieve  
                  table information from the source installation.  The error 
                  returned was: ";

     $message .= $tables->GetMessage();

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

if (empty($tables['data'])) {

     $message  = "An error was encountered while attempting to retrieve  
                  table information from the source installation.  No information
                  was found.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Formulate our return array.
// +--

$alt_found     = 0;
$tables_return = array();

foreach ($tables['data'] as $num => $row) {

     $tables_return[$row['tables_id']] = $row['tables_data_source'];

     if ($row['tables_data_source'] != 'CSV') {$alt_found++;}

} // End of foreach statement.

// +--
// | Connect to an RDBMS as specified in the settings if we found
// | at least one table with an alternate connection.
// +--

if ($alt_found) {

     // +--
     // | Load data from the altrdbms CSV table and formulate a DSN.
     // +--

     $altrdbms = $this->import_load_csvdata('altrdbms');
     $alttype  = $settings['alt_rdbms_type'];

     $username = '';
     $password = '';
     $hostname = '';
     $dbname   = '';
     $dbtype   = $alttype;

     if ($dbtype == 'MYSQL')     {$dbtype = 'mysql';}
     else                        {$dbtype = 'pgsql';}

     foreach ($altrdbms as $num => $row) {

          if ($row['altrdbms_type'] == $alttype) {

               if (($row['altrdbms_id'] == $alttype . '_host') || ($row['altrdbms_id'] == $alttype . '_server')) {

                    $hostname = $row['altrdbms_value'];

               } elseif (($row['altrdbms_id'] == $alttype . '_database') || ($row['altrdbms_id'] == $alttype . '_dbname')) {

                    $dbname = $row['altrdbms_value'];

               } elseif (($row['altrdbms_id'] == $alttype . '_username') || ($row['altrdbms_id'] == $alttype . '_uid')) {

                    $username = $row['altrdbms_value'];

               } elseif (($row['altrdbms_id'] == $alttype . '_password') || ($row['altrdbms_id'] == $alttype . '_pwd')) {

                    $password = $row['altrdbms_value'];

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     $password = $this->CORE_Crypt->decrypt($password,$settings['admin_register_ordernum']);

     $dsn = array('dbtype'   => $dbtype,
                  'username' => $username,
                  'password' => $password,
                  'hostname' => $hostname,
                  'dbname'   => $dbname);

     // +--
     // | Attempt to load CORE_DB using an alternate handle.
     // +--

     $this->CORE_DBX =& $this->CORE->load_object(array('app'       => 'core',
                                                       'class'     => 'CORE_DB',
                                                       'name'      => 'CORE_DB_2',
                                                       'construct' => $dsn));

     // +--
     // | Handle constructor errors.
     // +--

     if ($this->CORE->IsError($this->CORE_DBX)) {

          $message  = "An error was encountered while attempting to create a new
                       database object to connect to the RDBMS specified in the 
                       source installation.  The error returned was: ";

          $message .= $this->CORE_DBX->GetMessage();

          $result = $this->CORE->RaiseError($message);

          return $result;

     } // End of if statement.

     // +--
     // | Connect and handle errors.
     // +--

     $result = $this->CORE_DBX->connect();

     if ($this->CORE->IsError($result)) {

          $message  = "An error was encountered while attempting to connect to 
                       the RDBMS specified in the source installation.  The 
                       error returned was: ";

          $message .= $result->GetMessage();

          $result = $this->CORE->RaiseError($message);

          return $result;

     } // End of if statement.

} // End of if statement.

// +--
// | Return the settings.
// +--

return $tables_return;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_count_rows                                      |
// +------------------------------------------------------------------+

function import_count_rows ($table = '',$tabledefs = array()) {

// +--
// | This function counts the rows in a table and returns the count.
// +--

// +--
// | Return an error if we weren't passed a table to load or 
// | table definition information.
// +--

if ((empty($table)) || (empty($tabledefs))) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a table.  No table and/or table definition 
                  information was supplied.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Get the data based on the data source.
// +--

if ($tabledefs[$table] == 'CSV') {

     $data = $this->import_load_csvdata($table);

     return count($data);

} else {

     $count = $this->CORE_DBX->sql_count(array('table' => $table));

     if (($this->CORE->IsError($count)) || (empty($count))) {$count = 0;}

     return $count;

} // End of if statement.

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_data                                       |
// +------------------------------------------------------------------+

function import_load_data ($table = '',$tabledefs = array(),$offset = 0,$count = 100) {

// +--
// | This function loads data from a table.  It returns a DB-like
// | array.
// +--

// +--
// | Return an error if we weren't passed a table to load or 
// | table definition information.
// +--

if ((empty($table)) || (empty($tabledefs))) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a table.  No table and/or table definition 
                  information was supplied.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Get the data based on the data source.
// +--

if ($tabledefs[$table] == 'CSV') {

     $data = $this->import_load_csvdata($table);

     if ($count != 'ALL') {

          $data = array_slice($data, $offset, $count);

     } // End of if statement.

} else {

     $data = $this->import_load_rdbmsdata($table,$offset,$count);

} // End of if statement.

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_csvdata                                    |
// +------------------------------------------------------------------+

function import_load_csvdata ($table = '') {

// +--
// | This function loads data from a CSV file.  It returns a DB-like
// | array.
// +--

global $csvdata;

// +--
// | Return an error if we weren't passed a table to load.
// +--

if (empty($table)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a CSV-based table.  No table was supplied.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return cached data.
// +--

if (!(empty($csvdata[$table]))) {return $csvdata[$table];}

// +--
// | Load the data.
// +--

$file = $this->CORE->globals('core_cgi.import_dirdata') . '/tables/' . $table . '.csv';

$data = $this->CORE_File->parsecsv(array('filename' => $file));

// +--
// | Handle errors.
// +--

if ($this->CORE->IsError($data)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from the {$table} CSV-based table.  The error 
                  returned was: ";

     $message .= $data->GetMessage();

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

if (empty($data['data'])) {return array();}

$csvdata[$table] = $data['data'];

unset($data);

// +--
// | Return the data.
// +--

return $csvdata[$table];

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_rdbmsdata                                  |
// +------------------------------------------------------------------+

function import_load_rdbmsdata ($table = '',$offset = 0,$count = 100) {

// +--
// | This function loads data from a RDBMS table.  It returns a DB-like
// | array.
// +--

// +--
// | Return an error if we weren't passed a table to load.
// +--

if (empty($table)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a RDBMS-based table.  No table was supplied.";

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Load the data.
// +--

$columns = $this->CORE_DBX->table_column_string($table);

if ($this->CORE->IsError($columns)) {

     $message  = "An error was encountered while attempting to retrieve  
                  column information from the {$table} RDBMS-based table. 
                  The error returned was: ";

     $message .= $columns->GetMessage();

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

$sql  = "SELECT {$columns} FROM {$table}";

if ($count == 'ALL') {

     $data = $this->CORE_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array($table . '_id' => 'ASC')));

} else {

     $data = $this->CORE_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array($table . '_id' => 'ASC'),
                                           'count'  => $count,
                                           'offset' => $offset));

} // End of if statement.

// +--
// | Handle errors.
// +--

if ($this->CORE->IsError($data)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from the {$table} RDBMS-based table.  The error 
                  returned was: ";

     $message .= $data->GetMessage();

     $result = $this->CORE->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_filter                                          |
// +------------------------------------------------------------------+

function import_filter ($filter = '', $value = '',$settings = array()) {

// +--
// | This function loads settings from the source install.
// +--

$filtered = '';

if ((empty($value)) || (empty($settings))) {return $filtered;}

// +--
// | FILTER: yn2bool
// +--

if ($filter == 'yn2bool') {

     if ($value == 'Y') {$filtered = '1';} else {$filtered = '0';}

// +--
// | FILTER: password
// +--

} elseif ($filter == 'password') {

     $filtered = $this->CORE_Crypt->decrypt($value,$settings['admin_register_ordernum']);
     $filtered = md5($filtered);

// +--
// | FILTER: strtolower
// +--

} elseif ($filter == 'strtolower') {

     $filtered = strtolower($value);

// +--
// | FILTER: priceround
// +--

} elseif ($filter == 'priceround') {

     $price = round($value, 2);

     if (preg_match('/\./',$price)) {

          list($integer, $decimal) = preg_split('/\./i', $price, 2);

     } else {

          $integer = $price;
          $decimal = '0';

     } // End of if statement.

     while (strlen($decimal) < 2) {$decimal .= '0';}

     $filtered = $integer . '.' . $decimal;

} // End of if statement.

// +--
// | Return the filtered value.
// +--

return $filtered;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_changetags                                      |
// +------------------------------------------------------------------+

function import_changetags ($value = '') {

// +--
// | Returns a string stripped of all CGIVAR and CGIGET with 
// | links and image paths fixed.
// +--

if (empty($value)) {return $value;}

// +--
// | Images paths.
// +--

$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/site/','media/cms/html',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/category/','media/ecom/cat',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_category/','media/ecom/prodsm',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_detail/','media/ecom/prodlg',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_xlarge/','media/ecom/prodxl',$value);

// +--
// | URLs specifying reference strings.
// +--

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)prod\&ref\=(.*?)\"/','<?php print $this->link_namespace(\'ecom\',\'prodshow\',array(\'ref\' => \'\\2\')); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)cat\&ref\=(.*?)\"/','<?php print $this->link_namespace(\'ecom\',\'catshow\',array(\'ref\' => \'\\2\')); ?>"',$value);

// +--
// | Special URLs.
// +--

$owner_name = $this->CORE->globals('core_settings.core.site_name');

$value = preg_replace('/\(CGIVAR\)common_url_checkout\(\/CGIVAR\)"/','<?php print $this->link_namespace(\'ecom\',\'checkout\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url_custacct\(\/CGIVAR\)"/','<?php print $this->link_namespace(\'core\',\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url_affacct\(\/CGIVAR\)"/','<?php print $this->link_namespace(\'core\',\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)design_firm_url\(\/CGIVAR\)/','http://www.kryptronic.com',$value);
$value = preg_replace('/\(CGIVAR\)design_firm_name\(\/CGIVAR\)/','Kryptronic',$value);
$value = preg_replace('/\(CGIVAR\)site_owner_name\(\/CGIVAR\)/',$owner_name,$value);

// +--
// | URLs specifying system pages.
// +--

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)contact\"/','<?php print $this->link_namespace(\'core\',\'contact\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)maillist\"/','<?php print $this->link_namespace(\'core\',\'gsubscript\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)splash\"/','<?php print $this->link_namespace(\'cms\',\'display\',array(\'ref\' => \'splash\')); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)cart\"/','<?php print $this->link_namespace(\'ecom\',\'viewcart\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)store\"/','<?php print $this->link_namespace(\'ecom\',\'splash\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)search\"/','<?php print $this->link_namespace(\'ecom\',\'prodsearch\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)specials\"/','<?php print $this->link_namespace(\'ecom\',\'prodspec\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)bestsell\"/','<?php print $this->link_namespace(\'ecom\',\'prodbest\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)new\"/','<?php print $this->link_namespace(\'ecom\',\'prodnew\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)track\"/','<?php print $this->link_namespace(\'core\',\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)custacct\"/','<?php print $this->link_namespace(\'core\',\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)affacct\"/','<?php print $this->link_namespace(\'core\',\'login\',array()); ?>"',$value);

// +--
// | All other URLs.
// +--

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg\=(.*?)\"/','<?php print \'cms\',\'display\',array(\'ref\' => \'\\1\')); ?>"',$value);

// +--
// | Strip font tags.
// +--

$value = preg_replace('/\<FONT(.*?)\>/i','',$value);
$value = preg_replace('/\<\/FONT\>/i','',$value);

// +--
// | Fix some tags we care about.
// +--

$value = preg_replace('/\<B\>/i','<strong>',$value);
$value = preg_replace('/\<\/B\>/i','</strong>',$value);
$value = preg_replace('/\<BR\>/i','<br />',$value);

// +--
// | Strip anything within FORM tags.
// +--

$value = preg_replace('/\<FORM(.*?)\>(.*?)\<\/FORM\>/i','',$value);

// +--
// | Remove any CGIVAR and CGIGET tags that were not stripped.
// +--

$value = preg_replace('/\(CGIVAR\)(.*?)\(\/CGIVAR\)/','',$value);
$value = preg_replace('/\(CGIGET TYPE="(.*?)" VALUE="(.*?)" PARAMS="(.*?)"\)/','',$value);
$value = preg_replace('/\(CGIGET TYPE="(.*?)" VALUE="(.*?)"\)/','',$value);

// +--
// | Return the value.
// +--

return $value;

} // End of if statement.

// +------------------------------------------------------------------+
// | Function: import_price_round                                     |
// +------------------------------------------------------------------+

function import_price_round ($price = '0.00') {

// +--
// | Return a rounded price.
// +--

$price = round($price, 2);

if (preg_match('/\./',$price)) {

     list($integer, $decimal) = preg_split('/\./i', $price, 2);

} else {

     $integer = $price;
     $decimal = '0';

} // End of if statement.

while (strlen($decimal) < 2) {$decimal .= '0';}

return $integer . '.' . $decimal;

} // End of if statement.

// +------------------------------------------------------------------+
// | Function: fix_id                                                 |
// +------------------------------------------------------------------+

function fix_id ($id = '') {

if (empty($id)) {return $id;}

$id = preg_replace('/ /','-',$id);
$id = preg_replace('/[^a-zA-Z0-9\_\-]/','',$id);

while (preg_match('/\-\-/',$id)) {$id = preg_replace('/\-\-/','-',$id);}
while (preg_match('/^\-/',$id))  {$id = preg_replace('/^\-/','',$id);}
while (preg_match('/\-$/',$id))  {$id = preg_replace('/\-$/','',$id);}

return $id;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | End Of File                                                      |
// +------------------------------------------------------------------+

?>